﻿/*
 * goflow流程设计器插件
 * Author: Jimmy Cheung
 * Blog: http://www.cnblogs.com/eleven11/
*/
(function ($, undefined) {
    //定义流程模板属性
    TemplateProperty = function () {
        if (typeof TemplateProperty.defaults == "undefined") {
            /*第一次定义对象时为TemplateProperty类定义静态属性*/
            TemplateProperty.defaults = {
                data: {
                    RecNo: 0,
                    OrgNo: 0,
                    TemplateCode: "",
                    TemplateName: "",
                    InstanceName: "",
                    DesignWidth: 1000,
                    DesignHeight: 800,
                    Version: 0,
                    VerStatus: "设计",
                    DesignerName: "",
                    DesignTime: "",
                    PublisherName: "",
                    PublishTime: "",
                    TemplateMemo: ""
                }
            };
            /*第一次定义对象时定义实例共有方法*/
            var p = TemplateProperty.prototype;
            p.createTable = function () {
                this.$table = $("<table class='gf_prop_tb' cellpadding='0' cellspacing='0'></table>");
                this.$tbody = $("<tbody></tbody>");
                this.$table.append(this.$tbody);
                this.$propertyDiv.append(this.$table);
                //行0 - 基本属性（分组）
                this.$tbody.append(GoFlow.formatString(
                   "<tr style='display:table-row;background-color:rgb(234, 229, 229);height:0px;' group='TemplateBasic'>{0}</tr>",
                   "<td class='Expanded' group='TemplateBasic'></td><td style='width: 100%;height:0px;' colspan='3'>基本属性</td>"));
                //行1 - 流程编码
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateBasic' property='TemplateCode'><td/><td>流程编码</td>{0}</tr>",
                    "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));
                //行2 - 流程名称
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateBasic' property='TemplateName'><td/><td>流程名称</td>{0}</tr>",
                    "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));
                //行3 - 实例名称
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateBasic' property='InstanceName'><td/><td>实例名称</td>{0}{1}</tr>",
                    "<td><input id='InstanceName' style='width:98.9%;' type='text' maxlength='50'/></td>",
                    "<td style='min-width:35px;'><input class='BizData' type='button' value='...'/></td>"));

                //行4 - 版本信息（分组）
                this.$tbody.append(GoFlow.formatString(
                   "<tr style='display:table-row;background-color:rgb(234, 229, 229);height:0px;' group='TemplateVersion'>{0}</tr>",
                   "<td class='Expanded' group='TemplateVersion'></td><td style='width: 100%;height:0px;' colspan='3'>版本信息</td>"));
                //行5 - 流程版本
                this.$tbody.append(GoFlow.formatString("<tr group='TemplateVersion' property='Version'>{0}</tr>",
                    "<td/><td>流程版本</td><td colspan='2' readonly='true'><div></div></td>"));
                //行6 - 版本状态
                this.$tbody.append(GoFlow.formatString("<tr group='TemplateVersion' property='VerStatus'>{0}</tr>",
                    "<td/><td>版本状态</td><td colspan='2' readonly='true'><div></div></td>"));
                //行7 - 修改人
                this.$tbody.append(GoFlow.formatString("<tr group='TemplateVersion' property='DesignerName'>{0}</tr>",
                    "<td/><td>修改人</td><td colspan='2' readonly='true'><div></div></td>"));
                //行8 - 修改时间
                this.$tbody.append(GoFlow.formatString("<tr group='TemplateVersion' property='DesignTime'>{0}</tr>",
                    "<td/><td>修改时间</td><td colspan='2' readonly='true'><div></div></td>"));
                //行9 - 发布人
                this.$tbody.append(GoFlow.formatString("<tr group='TemplateVersion' property='PublisherName'>{0}</tr>",
                    "<td/><td>发布人</td><td colspan='2' readonly='true'><div></div></td>"));
                //行10 - 发布时间
                this.$tbody.append(GoFlow.formatString("<tr group='TemplateVersion' property='PublishTime'>{0}</tr>",
                    "<td/><td>发布时间</td><td colspan='2' readonly='true'><div></div></td>"));
                //行11 - 其他设置（分组）
                this.$tbody.append(GoFlow.formatString(
                   "<tr style='display:table-row;background-color:rgb(234, 229, 229);height:0px;' group='TemplateOther'>{0}</tr>",
                   "<td class='Expanded' group='TemplateOther'></td><td style='width: 100%;height:0px;' colspan='3'>其他设置</td>"));
                //行12 - 设计区域宽度
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='TemplateOther' property='DesignWidth'><td/><td>设计宽度</td>{0}</tr>",
                   "<td colspan='2'><input type='text' class='goflow-valid-int' maxlength='50'/></td>"));
                //行13 - 设计区域高度
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='TemplateOther' property='DesignHeight'><td/><td>设计高度</td>{0}</tr>",
                   "<td colspan='2'><input type='text' class='goflow-valid-int' maxlength='50'/></td>"));
                //行14 - 备注
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='TemplateOther' property='TemplateMemo'><td/><td>模板备注</td>{0}{1}</tr>",
                    "<td><div id='TemplateMemo' style='width:100%;word-break:break-all;word-wrap: break-word;'/></td>",
                    "<td style='min-width:35px;'><input class='BizData' type='button' value='...'/></td>"));

                //给控件赋值
                this.bindData();
                //绑定事件
                this.bindDelegate();
            };
            //把流程模板数据绑定到控件
            p.bindData = function (data) {
                var self = this;
                if (data) {
                    $.each(data, function (k, v) {
                        self.setData(k, v);
                    });
                } else {
                    $.each(self.$opts.data, function (k, v) {
                        self.setValue(k, v);
                    });
                }
            };
            //绑定事件
            p.bindDelegate = function () {
                //展开/收缩属性组
                this.$tbody.delegate("td[group].Fold,td[group].Expanded", "click", { self: this }, function (e) {
                    var $templateProp = e.data.self;
                    var fold = $(e.target).hasClass("Fold");
                    $(e.target).toggleClass("Fold", !fold);
                    $(e.target).toggleClass("Expanded", fold);
                    var selector = GoFlow.formatString(
                        "[group='{0}'][property]",
                        $(e.target).attr("group"));
                    $templateProp.$tbody.children(selector).toggle();
                });                
            };
            p.getData = function (key) {
                return this.$opts.data[key];
            };
            p.setData = function (key, value) {
                this.$opts.data[key] = value;
                this.setValue(key, value);
            };
            p.getValue = function (key) {
                switch (key) {
                    case "TemplateCode":
                        break;
                    case "TemplateName":
                        break;
                    case "InstanceName":
                        break;
                    case "Version":
                        break;
                    case "VerStatus":
                        break;
                    case "DesignerName":
                        break;
                    case "DesignTime":
                        break;
                    case "PublisherName":
                        break;
                    case "PublishTime":
                        break;
                    case "Memo":
                        break;
                    default:
                        break;
                };
            };
            p.setValue = function (key, value) {
                switch (key) {
                    case "TemplateCode":
                        this.$tbody.find("tr:eq(1) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "TemplateName":
                        this.$tbody.find("tr:eq(2) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "InstanceName":
                        this.$tbody.find("tr:eq(3) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "Version":
                        this.$tbody.find("tr:eq(5) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "VerStatus":
                        this.$tbody.find("tr:eq(6) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "DesignerName":
                        this.$tbody.find("tr:eq(7) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "DesignTime":
                        this.$tbody.find("tr:eq(8) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "PublisherName":
                        this.$tbody.find("tr:eq(9) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "PublishTime":
                        this.$tbody.find("tr:eq(10) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    case "DesignWidth":
                        this.$tbody.find("tr:eq(12) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "DesignHeight":
                        this.$tbody.find("tr:eq(13) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "TemplateMemo":
                        this.$tbody.find("tr:eq(14) > td:eq(2)").children("div:eq(0)").html(value);
                        break;
                    default:
                        break;
                };
            };
            //显示/隐藏
            p.setVisible = function (bool, data) {
                this.$table.css("display", bool ? "block" : "none");
                if (bool && data) {
                    this.bindData(data);
                }
            };
        }
    };
    //初始化TemplateProperty对象
    TemplateProperty.prototype.init = function (gf, pdiv, opts) {
        this.$gf = gf;
        this.$propertyDiv = pdiv;
        this.$opts = opts;
        this.createTable();
    };

    //定义开始节点属性
    StartProperty = function () {
        if (typeof StartProperty.defaults == "undefined") {
            /*第一次定义对象时为StartProperty类定义静态属性*/
            StartProperty.defaults = {
                data: {
                    id: "",
                    title: ""
                }
            };
            /*第一次定义对象时定义实例共有方法*/
            var p = StartProperty.prototype;
            p.createTable = function () {
                this.$table = $("<table class='gf_prop_tb' cellpadding='0' cellspacing='0'></table>").css("display", "none");
                this.$tbody = $("<tbody></tbody>");
                this.$table.append(this.$tbody);
                this.$propertyDiv.append(this.$table);
                //行0 - 基本属性（分组）
                this.$tbody.append(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);height:0px;' group='StartBasic'>{0}</tr>",
                    "<td class='Expanded' group='StartBasic'></td><td style='width: 100%;height:0px;' colspan='3'>基本属性</td>"));
                //行1 - 结束节点编码
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='StartBasic' property='NodeId'><td/><td>节点编码</td>{0}</tr>",
                    "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));
                //行2 -  结束节点名称
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='StartBasic' property='NodeTitle'><td/><td>节点名称</td>{0}</tr>",
                    "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));

                //给控件赋值
                this.bindData();
                //绑定事件
                this.bindDelegate();
            };
            //把流程模板数据绑定到控件
            p.bindData = function (data) {
                var self = this;
                if (data) self.$opts.data = data;
                $.each(self.$opts.data, function (k, v) {
                    self.setValue(k, v);
                });
            };
            //绑定事件
            p.bindDelegate = function () {
                //展开/收缩属性组
                this.$tbody.delegate("td[group].Fold,td[group].Expanded", "click", { self: this }, function (e) {
                    var $startProp = e.data.self;
                    var fold = $(e.target).hasClass("Fold");
                    $(e.target).toggleClass("Fold", !fold);
                    $(e.target).toggleClass("Expanded", fold);
                    var selector = GoFlow.formatString(
                        "[group='{0}'][property]",
                        $(e.target).attr("group"));
                    $startProp.$tbody.children(selector).toggle();
                });                
            };
            p.getData = function (key) {
                return this.$opts.data[key];
            };
            p.setData = function (key, value) {
                this.$opts.data[key] = value;
                this.setValue(key, value);
            };
            p.setValue = function (key, value) {
                switch (key) {
                    case "id":
                        this.$tbody.find("tr:eq(1) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "title":
                        this.$tbody.find("tr:eq(2) > td:eq(2)").children("input:first").val(value);
                        break;
                    default:
                        break;
                };
            };
            //显示/隐藏
            p.setVisible = function (bool, data) {
                this.$table.css("display", bool ? "block" : "none");
                if (bool && data) {
                    this.bindData(data);
                }
            };
        }
    };
    //初始化StartProperty对象
    StartProperty.prototype.init = function (pdiv, opts) {
        this.$propertyDiv = pdiv;
        this.$opts = opts;
        this.createTable();
    };

    //定义结束节点属性
    EndProperty = function () {
        if (typeof EndProperty.defaults == "undefined") {
            /*第一次定义对象时为EndProperty类定义静态属性*/
            EndProperty.defaults = {
                data: {
                    id: "",
                    title: ""
                }
            };
            /*第一次定义对象时定义实例共有方法*/
            var p = EndProperty.prototype;
            p.createTable = function () {
                this.$table = $("<table class='gf_prop_tb' cellpadding='0' cellspacing='0'></table>").css("display", "none");
                this.$tbody = $("<tbody></tbody>");
                this.$table.append(this.$tbody);
                this.$propertyDiv.append(this.$table);
                //行0 - 基本属性（分组）
                this.$tbody.append(GoFlow.formatString(
                   "<tr style='display:table-row;background-color:rgb(234, 229, 229);height:0px;' group='EndBasic'>{0}</tr>",
                   "<td class='Expanded' group='EndBasic'></td><td style='width: 100%;height:0px;' colspan='3'>基本属性</td>"));
                //行1 - 结束节点编码
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='EndBasic' property='NodeId'><td/><td>节点编码</td>{0}</tr>",
                    "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));
                //行2 -  结束节点名称
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='EndBasic' property='NodeTitle'><td/><td>节点名称</td>{0}</tr>",
                    "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));

                //给控件赋值
                this.bindData();
                //绑定事件
                this.bindDelegate();
            };
            //把流程模板数据绑定到控件
            p.bindData = function (data) {
                var self = this;
                if (data) self.$opts.data = data;
                $.each(self.$opts.data, function (k, v) {
                    self.setValue(k, v);
                });
            };
            //绑定事件
            p.bindDelegate = function () {
                //展开/收缩属性组
                this.$tbody.delegate("td[group].Fold,td[group].Expanded", "click", { self: this }, function (e) {
                    var $endProp = e.data.self;
                    var fold = $(e.target).hasClass("Fold");
                    $(e.target).toggleClass("Fold", !fold);
                    $(e.target).toggleClass("Expanded", fold);
                    var selector = GoFlow.formatString(
                        "[group='{0}'][property]",
                        $(e.target).attr("group"));
                    $endProp.$tbody.children(selector).toggle();
                });
            };
            p.getData = function (key) {
                return this.$opts.data[key];
            };
            p.setData = function (key, value) {
                this.$opts.data[key] = value;
                this.setValue(key, value);
            };
            p.setValue = function (key, value) {
                switch (key) {
                    case "id":
                        this.$tbody.find("tr:eq(1) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "title":
                        this.$tbody.find("tr:eq(2) > td:eq(2)").children("input:first").val(value);
                        break;
                    default:
                        break;
                };
            };
            //显示/隐藏
            p.setVisible = function (bool, data) {
                this.$table.css("display", bool ? "block" : "none");
                if (bool && data) {
                    this.bindData(data);
                }
            };
        }
    };
    //初始化EndProperty对象
    EndProperty.prototype.init = function (pdiv, opts) {
        this.$propertyDiv = pdiv;
        this.$opts = opts;
        this.createTable();
    };

    //定义活动节点属性
    ActivityProperty = function () {
        if (typeof ActivityProperty.defaults == "undefined") {
            /*第一次定义对象时为ActivityProperty类定义静态属性*/
            ActivityProperty.defaults = {
                data: {
                    RecNo: 0,
                    TempNo: 0,
                    ElementNo: 0,
                    ActivityCode: "Activity1",
                    ActivityName: "活动1",
                    ActivityType: 1,/*1:串签；2:并签*/
                    ParallelRule: 1,/*1:一票否决；2:一票通过；3:少数服从多数*/
                    NoApprover: false, //无参与者（不做处理/审批通过）
                    IsWriter: false,  //是发起人（不做处理/审批通过）
                    IsPrior: false,  //前一活动参与（不做处理/审批通过）
                    IsApproved: false,  //参与过流程（不做处理/审批通过）
                    CanChange: false, //转处理人
                    CanHandling: false, //正在处理中
                    CanStop: false, //终止流程
                    CanCollect: false, //征询意见
                    CanHandRound: false, //传阅
                    CanReturnStart: false, //驳回开始
                    CanReturnPrior: false, //驳回上一步
                    CanReturnAny: false, //驳回任一步
                    AllowMail: true, //邮件通知
                    AllowMessage: true, //消息通知
                    Approvers: [] //参与者（多个）
                }
            };
            /*第一次定义对象时定义实例共有方法*/
            var p = ActivityProperty.prototype;
            p.createTable = function () {
                this.$table = $("<table class='gf_prop_tb' cellpadding='0' cellspacing='0' style='display:none;'></table>");
                this.$tbody = $("<tbody></tbody>");
                this.$table.append(this.$tbody);
                this.$propertyDiv.append(this.$table);
                //行0 - 基本属性（分组）
                this.$trActivityBasic = $(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);' group='ActivityBasic'>{0}</tr>",
                    "<td class='Expanded' group='ActivityBasic'></td><td style='width: 100%;' colspan='3'>基本属性</td>"));
                this.$tbody.append(this.$trActivityBasic);
                //行1 - 活动编码
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityBasic' property='ActivityCode'><td/><td>活动编码</td>{0}</tr>",
                   "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));
                //行2 - 活动名称
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityBasic' property='ActivityName'><td/><td>活动名称</td>{0}</tr>",
                   "<td colspan='2'><input type='text' maxlength='50'/></td>"));
                //行3 - 活动类型
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityBasic' property='ActivityType'><td/><td>活动类型</td><td colspan='2'>{0}{1}</td></tr>",
                   "<label for='ActivityType1'><input type='radio' id='ActivityType1' value='1' name='ActivityType'/>串签</label>",
                   "<label for='ActivityType2' style='padding-left:39px;'><input type='radio' id='ActivityType2' value='2' name='ActivityType'/>并签</label>"));
                //行4 - 并签规则
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityBasic' property='ParallelRule'><td/><td>并签规则</td><td colspan='2'>{0}{1}{2}</td></tr>",
                   "<label for='ParallelRule1'><input type='radio' id='ParallelRule1' value='1' name='ParallelRule'/>一票通过</label>",
                   "<label for='ParallelRule2' style='padding-left:15px;'><input type='radio' id='ParallelRule2' value='2' name='ParallelRule'/>一票否决</label>",
                   "<label for='ParallelRule3' style='padding-left:15px;'><input type='radio' id='ParallelRule3' value='3' name='ParallelRule'/>少数服从多数</label>"));
                //行5 - 参与者（分组）
                this.$tbody.append(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);' group='ActivityApprover'>{0}</tr>",
                    "<td class='Expanded' group='ActivityApprover'></td><td style='width: 100%;' colspan='3'>参与者</td>"));
                //行6 - 参与者
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='ActivityApprover' property='Approvers'><td/><td>参与者</td>{0}{1}</tr>",
                    "<td><div id='Approvers' style='width:100%;'/></td>",
                    "<td style='min-width:35px;'><input class='BizData' type='button' value='...'/></td>"));
                //行7 - 无参与者
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityApprover' property='NoApprover'><td/><td>无参与者</td><td colspan='2'>{0}{1}</td></tr>",
                   "<label for='NoApprover0'><input type='radio' id='NoApprover0' value='false' name='NoApprover'/>不做处理</label>",
                   "<label for='NoApprover1' style='padding-left:15px;'><input type='radio' id='NoApprover1' value='true' name='NoApprover'/>审批通过</label>"));
                //行8 - 是发起人
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityApprover' property='IsWriter'><td/><td>是发起人</td><td colspan='2'>{0}{1}</td></tr>",
                   "<label for='IsWriter0'><input type='radio' id='IsWriter0' value='false' name='IsWriter'/>不做处理</label>",
                   "<label for='IsWriter1' style='padding-left:15px;'><input type='radio' id='IsWriter1' value='true' name='IsWriter'/>审批通过</label>"));
                //行9 - 前一活动参与
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityApprover' property='IsPrior'><td/><td>前一活动参与</td><td colspan='2'>{0}{1}</td></tr>",
                   "<label for='IsPrior0'><input type='radio' id='IsPrior0' value='false' name='IsPrior'/>不做处理</label>",
                   "<label for='IsPrior1' style='padding-left:15px;'><input type='radio' id='IsPrior1' value='true' name='IsPrior'/>审批通过</label>"));
                //行10 - 参与过流程
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityApprover' property='IsApproved'><td/><td>参与过流程</td><td colspan='2'>{0}{1}</td></tr>",
                   "<label for='IsApproved0'><input type='radio' id='IsApproved0' value='false' name='IsApproved'/>不做处理</label>",
                   "<label for='IsApproved1' style='padding-left:15px;'><input type='radio' id='IsApproved1' value='true' name='IsApproved'/>审批通过</label>"));
                //行11 - 操作权限（分组）
                this.$tbody.append(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);' group='OperAuthority'>{0}</tr>",
                    "<td class='Expanded' group='OperAuthority'></td><td style='width: 100%;' colspan='3'>操作权限</td>"));
                //行12 - 基本操作
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='OperAuthority' property='BaseOper'><td/><td>基本操作</td><td colspan='2'>{0}{1}{2}</td></tr>",
                   "<label for='CanChange'><input type='checkbox' id='CanChange'/>转处理人</label>",
                   "<label for='CanHandling' style='padding-left:15px;'><input type='checkbox' id='CanHandling'/>正在处理中</label>",
                   "<label for='CanStop' style='padding-left:15px;'><input type='checkbox' id='CanStop'/>终止流程</label>"));
                //行13 - 协办操作
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='OperAuthority' property='AssistantOper'><td/><td>协办操作</td><td colspan='2'>{0}{1}</td></tr>",
                   "<label for='CanCollect'><input type='checkbox' id='CanCollect'/>征询意见</label>",
                   "<label for='CanHandRound' style='padding-left:15px;'><input type='checkbox' id='CanHandRound'/>传阅</label>"));
                //行14 - 驳回操作
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='OperAuthority' property='RejectOper'><td/><td>驳回操作</td><td colspan='2'>{0}{1}{2}</td></tr>",
                   "<label for='CanReturnStart'><input type='checkbox' id='CanReturnStart'/>驳回开始</label>",
                   "<label for='CanReturnPrior' style='padding-left:15px;'><input type='checkbox' id='CanReturnPrior'/>驳回上一步</label>",
                   "<label for='CanReturnAny' style='padding-left:15px;'><input type='checkbox' id='CanReturnAny'/>驳回任一步</label>"));
                //行15 - 通知设置（分组）
                this.$tbody.append(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);' group='ActivityNotify'>{0}</tr>",
                    "<td class='Expanded' group='ActivityNotify'></td><td style='width: 100%;' colspan='3'>通知设置</td>"));
                //行16 - 通知设置
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ActivityNotify' property='ActivityNotify'><td/><td>通知设置</td><td colspan='2'>{0}{1}</td></tr>",
                   "<label for='AllowMail'><input type='checkbox' id='AllowMail'/>邮件通知</label>",
                   "<label for='AllowMessage' style='padding-left:15px;'><input type='checkbox' id='AllowMessage'/>消息通知</label>"));

                //给控件赋值
                this.bindData();
                //绑定事件
                this.bindDelegate();
            };
            //把活动数据绑定到控件
            p.bindData = function (data) {
                var self = this;
                if (data) self.$opts.data = data;
                $.each(self.$opts.data, function (k, v) {
                    self.setValue(k, v);
                });
            };
            //绑定事件
            p.bindDelegate = function () {
                //展开/收缩属性组
                this.$tbody.delegate("td[group].Fold,td[group].Expanded", "click", { self: this }, function (e) {
                    var $activityProp = e.data.self;
                    var fold = $(e.target).hasClass("Fold");
                    $(e.target).toggleClass("Fold", !fold);
                    $(e.target).toggleClass("Expanded", fold);
                    var selector = GoFlow.formatString(
                        "[group='{0}'][property]",
                        $(e.target).attr("group"));
                    $activityProp.$tbody.children(selector).toggle();
                });
            };
            p.getData = function (key) {
                return this.$opts.data[key];
            };
            p.setData = function (key, value) {
                this.$opts.data[key] = value;
                this.setValue(key, value);
            };
            p.getValue = function (key) {
                switch (key) {
                    default:
                        break;
                };
            };
            p.setValue = function (key, value) {
                switch (key) {
                    case "ActivityCode":
                        this.$tbody.find("tr:eq(1) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "ActivityName":
                        this.$tbody.find("tr:eq(2) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "ActivityType":
                        this.$tbody.find("tr:eq(3) > td:eq(2)").find("input[value='" + value + "']").prop("checked", true);
                        this.setParallelRuleReadonly(value == "1");
                        break;
                    case "ParallelRule":
                        this.$tbody.find("tr:eq(4) > td:eq(2)").find("input[value='" + value + "']").prop("checked", true);
                        break;
                    case "Approvers":
                        var $divApprovers = this.$tbody.find("#Approvers").empty();
                        $.each(value, function (idx, item) {
                            $divApprovers.append(GoFlow.formatString(
                                "<div style='width:100%;padding:2px;'>{0} - {1}</div>", item.ApproveOrder, item.ApproverText));
                        });
                        break;
                    case "NoApprover":
                        this.$tbody.find("tr:eq(7) > td:eq(2)").find("input[value='" + value + "']").prop("checked", true);
                        break;
                    case "IsWriter":
                        this.$tbody.find("tr:eq(8) > td:eq(2)").find("input[value='" + value + "']").prop("checked", true);
                        break;
                    case "IsPrior":
                        this.$tbody.find("tr:eq(9) > td:eq(2)").find("input[value='" + value + "']").prop("checked", true);
                        break;
                    case "IsApproved":
                        this.$tbody.find("tr:eq(10) > td:eq(2)").find("input[value='" + value + "']").prop("checked", true);
                        break;
                    case "CanChange":
                        this.$tbody.find("tr:eq(12) > td:eq(2)").find("input[id='CanChange']").prop("checked", value);
                        break;
                    case "CanHandling":
                        this.$tbody.find("tr:eq(12) > td:eq(2)").find("input[id='CanHandling']").prop("checked", value);
                        break;
                    case "CanStop":
                        this.$tbody.find("tr:eq(12) > td:eq(2)").find("input[id='CanStop']").prop("checked", value);
                        break;
                    case "CanCollect":
                        this.$tbody.find("tr:eq(13) > td:eq(2)").find("input[id='CanCollect']").prop("checked", value);
                        break;
                    case "CanHandRound":
                        this.$tbody.find("tr:eq(13) > td:eq(2)").find("input[id='CanHandRound']").prop("checked", value);
                        break;
                    case "CanReturnStart":
                        this.$tbody.find("tr:eq(14) > td:eq(2)").find("input[id='CanReturnStart']").prop("checked", value);
                        break;
                    case "CanReturnPrior":
                        this.$tbody.find("tr:eq(14) > td:eq(2)").find("input[id='CanReturnPrior']").prop("checked", value);
                        break;
                    case "CanReturnAny":
                        this.$tbody.find("tr:eq(14) > td:eq(2)").find("input[id='CanReturnAny']").prop("checked", value);
                        break;
                    case "AllowMail":
                        this.$tbody.find("tr:eq(16) > td:eq(2)").find("input[id='AllowMail']").prop("checked", value);
                        break;
                    case "AllowMessage":
                        this.$tbody.find("tr:eq(16) > td:eq(2)").find("input[id='AllowMessage']").prop("checked", value);
                        break;
                    default:
                        break;
                };
            };
            //设置并签规则是否只读
            p.setParallelRuleReadonly = function (bool) {
                if (bool) {
                    this.$tbody.find("tr:eq(4) > td:eq(2)").attr("readonly", "true")
                    this.$tbody.find("tr:eq(4) > td:eq(2)").find("input").attr("disabled", "disabled");
                }
                else {
                    this.$tbody.find("tr:eq(4) > td:eq(2)").removeAttr("readonly");
                    this.$tbody.find("tr:eq(4) > td:eq(2)").find("input").removeAttr("disabled");
                }
            };
            //显示/隐藏
            p.setVisible = function (bool, data) {
                this.$table.css("display", bool ? "block" : "none");
                if (bool && data) {
                    this.bindData(data);
                }
            };
        }
    };
    //初始化ActivityProperty对象
    ActivityProperty.prototype.init = function (gf, pdiv, opts) {
        this.$gf = gf;
        this.$propertyDiv = pdiv;
        this.$opts = opts;
        this.createTable();
    };

    //定义连线节点属性
    LineProperty = function () {
        if (typeof LineProperty.defaults == "undefined") {
            /*第一次定义对象时为LineProperty类定义静态属性*/
            LineProperty.defaults = {
                data: {
                    RecNo: 0,
                    TempNo: 0,
                    ElementNo: 0,
                    LineCode: "Line_1",
                    LineTitle: "",
                    LineType: 'I',/*连线类型（I/Z/N）*/
                    FromElementCode: "",
                    FromElementName: '',
                    ToElementCode: "",
                    ToElementName: ''
                }
            };
            /*第一次定义对象时定义实例共有方法*/
            var p = LineProperty.prototype;
            p.createTable = function () {
                this.$table = $("<table class='gf_prop_tb' cellpadding='0' cellspacing='0' style='display:none;'></table>");
                this.$tbody = $("<tbody></tbody>");
                this.$table.append(this.$tbody);
                this.$propertyDiv.append(this.$table);
                //行0 - 基本属性（分组）
                this.$trLineBasic = $(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);' group='LineBasic'>{0}</tr>",
                    "<td class='Expanded' group='LineBasic'></td><td style='width: 100%;' colspan='3'>基本属性</td>"));
                this.$tbody.append(this.$trLineBasic);
                //行1 - 连线编码
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='LineBasic' property='LineCode'><td/><td>连线编码</td>{0}</tr>",
                   "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));
                //行2 - 连线名称
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='LineBasic' property='LineTitle'><td/><td>连线名称</td>{0}</tr>",
                   "<td colspan='2'><input type='text' maxlength='50'/></td>"));
                //行3 - 连接节点（分组）
                this.$tbody.append(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);' group='LineNode'>{0}</tr>",
                    "<td class='Expanded' group='LineNode'></td><td style='width: 100%;' colspan='3'>连接节点</td>"));
                //行4 - 开始节点
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='LineNode' property='FromElementName'><td/><td>开始节点</td>{0}</tr>",
                   "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));
                //行5 - 结束节点
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='LineNode' property='ToElementName'><td/><td>结束节点</td>{0}</tr>",
                   "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));

                //给控件赋值
                this.bindData();
                //绑定事件
                this.bindDelegate();
            };
            //把连线数据绑定到控件
            p.bindData = function (data) {
                var self = this;
                if (data) self.$opts.data = data;
                $.each(self.$opts.data, function (k, v) {
                    self.setValue(k, v);
                });
            };
            //绑定事件
            p.bindDelegate = function () {
                //展开/收缩属性组
                this.$tbody.delegate("td[group].Fold,td[group].Expanded", "click", { self: this }, function (e) {
                    var $lineProp = e.data.self;
                    var fold = $(e.target).hasClass("Fold");
                    $(e.target).toggleClass("Fold", !fold);
                    $(e.target).toggleClass("Expanded", fold);
                    var selector = GoFlow.formatString(
                        "[group='{0}'][property]",
                        $(e.target).attr("group"));
                    $lineProp.$tbody.children(selector).toggle();
                });
            };
            p.getData = function (key) {
                return this.$opts.data[key];
            };
            p.setData = function (key, value) {
                this.$opts.data[key] = value;
                this.setValue(key, value);
            };
            p.getValue = function (key) {
                switch (key) {
                    default:
                        break;
                };
            };
            p.setValue = function (key, value) {
                switch (key) {
                    case "LineCode":
                        this.$tbody.find("tr:eq(1) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "LineTitle":
                        this.$tbody.find("tr:eq(2) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "FromElementName":
                        this.$tbody.find("tr:eq(4) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "ToElementName":
                        this.$tbody.find("tr:eq(5) > td:eq(2)").children("input:first").val(value);
                        break;
                    default:
                        break;
                };
            };
            //显示/隐藏
            p.setVisible = function (bool, data) {
                this.$table.css("display", bool ? "block" : "none");
                if (bool && data) {
                    this.bindData(data);
                }
            };
        }
    };
    //初始化LineProperty对象
    LineProperty.prototype.init = function (gf, pdiv, opts) {
        this.$gf = gf;
        this.$propertyDiv = pdiv;
        this.$opts = opts;
        this.createTable();
    };

    //定义条件节点属性
    ConditionProperty = function () {
        if (typeof ConditionProperty.defaults == "undefined") {
            /*第一次定义对象时为ConditionProperty类定义静态属性*/
            ConditionProperty.defaults = {
                data: {
                    RecNo: 0,
                    TempNo: 0,
                    ElementNo: 0,
                    ConditionCode: "Condition_1",
                    ConditionTitle: "",
                    ElementCodeForTrue: "",
                    ElementNameForTrue: "",
                    ElementCodeForFalse: "",
                    ElementNameForFalse: "",
                    Expressions: [] //条件表达式（多个）
                }
            };
            /*第一次定义对象时定义实例共有方法*/
            var p = ConditionProperty.prototype;
            p.createTable = function () {
                this.$table = $("<table class='gf_prop_tb' cellpadding='0' cellspacing='0' style='display:none;'></table>");
                this.$tbody = $("<tbody></tbody>");
                this.$table.append(this.$tbody);
                this.$propertyDiv.append(this.$table);
                //行0 - 基本属性（分组）
                this.$trConditionBasic = $(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);' group='ConditionBasic'>{0}</tr>",
                    "<td class='Expanded' group='ConditionBasic'></td><td style='width: 100%;' colspan='3'>基本属性</td>"));
                this.$tbody.append(this.$trConditionBasic);
                //行1 - 条件编码
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ConditionBasic' property='ConditionCode'><td/><td>条件编码</td>{0}</tr>",
                   "<td colspan='2' readonly='true'><input type='text' maxlength='50' readonly='readonly'/></td>"));
                //行2 - 条件名称
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ConditionBasic' property='ConditionTitle'><td/><td>条件名称</td>{0}</tr>",
                   "<td colspan='2'><input type='text' maxlength='50'/></td>"));
                //行3 - 条件公式
                this.$tbody.append(GoFlow.formatString(
                    "<tr group='ConditionBasic' property='Expressions'><td/><td>条件公式</td>{0}{1}</tr>",
                    "<td><div id='Expressions' style='width:100%;'/></td>",
                    "<td style='min-width:35px;'><input class='BizData' type='button' value='...'/></td>"));
                //行4 - 连接节点（分组）
                this.$tbody.append(GoFlow.formatString(
                    "<tr style='display:table-row;background-color:rgb(234, 229, 229);' group='ConditionNode'>{0}</tr>",
                    "<td class='Expanded' group='ConditionNode'></td><td style='width: 100%;' colspan='3'>连接节点</td>"));
                //行5 - 条件为真
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ConditionNode' property='ElementNameForTrue'><td/><td>条件为真</td>{0}{1}</tr>",
                   "<td readonly='true'><input id='ElementNameForTrue' style='width:100%;' type='text' maxlength='50' readonly='true'/></td>",
                   "<td style='min-width:35px;' readonly='true'><input class='BizData' type='button' value='...'/></td>"));
                //行6 - 条件为假
                this.$tbody.append(GoFlow.formatString(
                   "<tr group='ConditionNode' property='ElementNameForFalse'><td/><td>条件为假</td>{0}{1}</tr>",
                   "<td readonly='true'><input id='ElementNameForFalse' style='width:100%;' type='text' maxlength='50' readonly='true'/></td>",
                   "<td style='min-width:35px;' readonly='true'><input class='BizData' type='button' value='...'/></td>"));

                //给控件赋值
                this.bindData();
                //绑定事件
                this.bindDelegate();
            };
            //把条件数据绑定到控件
            p.bindData = function (data) {
                var self = this;
                if (data) self.$opts.data = data;
                $.each(self.$opts.data, function (k, v) {
                    self.setValue(k, v);
                });
            };
            //绑定事件
            p.bindDelegate = function () {
                //展开/收缩属性组
                this.$tbody.delegate("td[group].Fold,td[group].Expanded", "click", { self: this }, function (e) {
                    var $conditionProp = e.data.self;
                    var fold = $(e.target).hasClass("Fold");
                    $(e.target).toggleClass("Fold", !fold);
                    $(e.target).toggleClass("Expanded", fold);
                    var selector = GoFlow.formatString(
                        "[group='{0}'][property]",
                        $(e.target).attr("group"));
                    $conditionProp.$tbody.children(selector).toggle();
                });
            };
            p.getData = function (key) {
                return this.$opts.data[key];
            };
            p.setData = function (key, value) {
                this.$opts.data[key] = value;
                this.setValue(key, value);
            };
            p.getValue = function (key) {
                switch (key) {
                    default:
                        break;
                };
            };
            p.setValue = function (key, value) {
                switch (key) {
                    case "ConditionCode":
                        this.$tbody.find("tr:eq(1) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "ConditionTitle":
                        this.$tbody.find("tr:eq(2) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "Expressions":
                        var $divExpressions = this.$tbody.find("#Expressions").empty();
                        $.each(value, function (idx, item) {
                            $divExpressions.append(GoFlow.formatString(
                                "<div style='width:100%;padding:2px;'>{0} {1} {2} {3}</div>",
                                item.LeftValue, item.LogicalOper, item.RightValue, item.RelationOper));
                        });
                        break;
                    case "ElementNameForTrue":
                        this.$tbody.find("tr:eq(5) > td:eq(2)").children("input:first").val(value);
                        break;
                    case "ElementNameForFalse":
                        this.$tbody.find("tr:eq(6) > td:eq(2)").children("input:first").val(value);
                        break;
                    default:
                        break;
                };
            };
            //显示/隐藏
            p.setVisible = function (bool, data) {
                this.$table.css("display", bool ? "block" : "none");
                if (bool && data) {
                    this.bindData(data);
                }
            };
        }
    };
    //初始化ConditionProperty对象
    ConditionProperty.prototype.init = function (gf, pdiv, opts) {
        this.$gf = gf;
        this.$propertyDiv = pdiv;
        this.$opts = opts;
        this.createTable();
    };

    //定义GoFlow类
    GoFlow = function () {
        if (typeof GoFlow.useSVG == "undefined") {
            /*第一次定义对象时为GoFlow类定义静态属性和静态方法*/
            /*静态属性*/
            //如果是IE6，IE7或者IE8则使用vml，其他浏览器使用svg。
            GoFlow.useSVG =
                (navigator.userAgent.indexOf("MSIE 8.0") > 0
                || navigator.userAgent.indexOf("MSIE 7.0") > 0
                || navigator.userAgent.indexOf("MSIE 6.0") > 0) ? false : true;
            //默认参数
            GoFlow.defaults = {
                width: 800,
                height: 500,
                workAreaWidth: 3758,
                workAreaHeight: 1836,
                haveHead: true,
                haveTool: true,
                useOperStack: true,
                toolOperBtn: {
                    "save": "保存",
                    "undo": "撤消",
                    "redo": "重做",
                    "reload": "刷新"
                },
                toolBoxBtn: {
                    "start": "开始结点",
                    "activity": "活动结点",
                    "condition": "条件结点",
                    "end": "结束结点"
                },
                onBtnReloadClick: null, //重载流程图按钮单击事件
                onBtnSaveClick: null, //保存流程图按钮单击事件
                onBtnPublishClick: null, //发布流程按钮单击事件
                onBtnReplaceClick: null, //覆盖流程按钮单击事件
                onBtnOpenClick: null, //打开流程按钮单击事件
                onItemAdd: null,
                onItemDel: null,
                onItemMove: null,
                onItemBlur: null,
                onItemFocus: null,
                onItemResize: null,
                onItemSetTitle: null,
                onLineMove: null,
                onLineSetType: null,
                onItemMark: null
            };

            /*静态方法（通用方法）*/
            //兼容各种浏览器的,获取鼠标真实位置
            GoFlow.mousePosition = function (ev) {
                if (!ev) ev = window.event;
                if (ev.pageX || ev.pageY) {
                    return { x: ev.pageX, y: ev.pageY };
                }
                return {
                    x: ev.clientX + document.documentElement.scrollLeft - document.body.clientLeft,
                    y: ev.clientY + document.documentElement.scrollTop - document.body.clientTop
                };
            };
            //获取一个DIV的绝对坐标的功能函数,即使是非绝对定位,一样能获取到
            GoFlow.getElCoordinate = function (dom) {
                var t = dom.offsetTop;
                var l = dom.offsetLeft;
                dom = dom.offsetParent;
                while (dom) {
                    t += dom.offsetTop;
                    l += dom.offsetLeft;
                    dom = dom.offsetParent;
                };
                return { top: t, left: l };
            };
            //限制只能输入整数
            GoFlow.validInt = function (e) {
                if (!e) e = window.event;
                if (!(e.keyCode == 46) && !(e.keyCode == 8) && !(e.keyCode == 37) && !(e.keyCode == 39)) {
                    if (!((e.keyCode >= 48 && e.keyCode <= 57) || (e.keyCode >= 96 && e.keyCode <= 105)))
                        return false;
                }
                return true;
            };
            //模拟实现C# String.format函数
            GoFlow.formatString = function () {
                var formatStr = arguments[0];
                if (typeof formatStr === 'string') {
                    var pattern;
                    for (var i = 1; i < arguments.length; i++) {
                        pattern = new RegExp('\\{' + (i - 1) + '\\}', 'g');
                        formatStr = formatStr.replace(pattern, arguments[i]);
                    }
                }
                else {
                    formatStr = '';
                }
                return formatStr;
            };
            /*静态方法(流程设计器相关方法)*/
            //获取svg箭头
            GoFlow.getSvgMarker = function (id, color) {
                var m = document.createElementNS("http://www.w3.org/2000/svg", "marker");
                m.setAttribute("id", id);
                m.setAttribute("viewBox", "0 0 6 6");
                m.setAttribute("refX", 5);
                m.setAttribute("refY", 3);
                m.setAttribute("markerUnits", "strokeWidth");
                m.setAttribute("markerWidth", 6);
                m.setAttribute("markerHeight", 6);
                m.setAttribute("orient", "auto");
                var path = document.createElementNS("http://www.w3.org/2000/svg", "path");
                path.setAttribute("d", "M 0 0 L 6 3 L 0 6 z");
                path.setAttribute("fill", color);
                path.setAttribute("stroke-width", 0);
                m.appendChild(path);
                return m;
            };

            /*第一次定义对象时定义实例共有方法*/
            var p = GoFlow.prototype;
            //设计器div:jQuery对象
            p.gfDiv = function () {
                return $(this).data('gfDiv');
            };

            /*1.初始化方法*/
            //1.1计算宽度
            p.calcWidth = function () {
                this.$opts.sWidth = !this.$editable && 0 || this.$opts.sWidth || 6;
                this.$opts.dWidth = !this.$editable && this.$opts.width || (this.$opts.width - this.$opts.sWidth) * 0.75;
                this.$opts.pWidth = !this.$editable && 0 || (this.$opts.width - this.$opts.dWidth - this.$opts.sWidth);
            };
            //1.2生成设计器、分隔条和属性
            p.createDiv = function () {
                this.calcWidth();                
                this.$designerDiv = $(GoFlow.formatString("<div class='gf_d' style='width:{0}px;height:{1}px;float:left;'></div>", this.$opts.dWidth, this.$opts.height));
                this.$gfDiv.append(this.$designerDiv);
                if (this.$editable) {
                    //创建分隔条
                    this.$sliderDiv = $(GoFlow.formatString("<div class='gf_s' style='width:{0}px;height:{1}px;float:left;'></div>", this.$opts.sWidth - 2, this.$opts.height));
                    this.$gfDiv.append(this.$sliderDiv);
                    //分隔条幽灵
                    this.$sliderGhostDiv = $(GoFlow.formatString("<div class='gf_s_g' style='width:{0}px;height:{1}px;float:left;'></div>", this.$opts.sWidth - 2, this.$opts.height));
                    this.$gfDiv.append(this.$sliderGhostDiv);

                    //创建属性
                    this.$propertyDiv = $(GoFlow.formatString("<div class='gf_p' style='width:{0}px;height:{1}px;float: left;'></div>", this.$opts.pWidth - 2, this.$opts.height));
                    this.$gfDiv.append(this.$propertyDiv);
                    //创建属性标题
                    this.$propertyHeadDiv = $(GoFlow.formatString("<div class='gf_p_head' style='width:{0}px;'></div>", this.$opts.pWidth - 2));
                    this.$propertyHeadDiv.append("<div class='gf_p_head_toggle'></div>");
                    this.$propertyHeadDiv.append(GoFlow.formatString("<div class='gf_p_head_inner'>{0}{1}</div>", "流程模板属性：", "新流程1"));
                    this.$propertyDiv.append(this.$propertyHeadDiv);
                    //创建属性容器
                    this.$propertyBodyDiv = $(GoFlow.formatString("<div class='gf_p_body' style='height:{0}px;'></div>", this.$opts.height - 29));
                    this.$propertyDiv.append(this.$propertyBodyDiv);

                    //创建属性收缩起来后显示的div
                    this.$collapseDiv = $(GoFlow.formatString("<div class='gf_collapse' style='height:{0}px;display:none;'></div>", this.$opts.height));
                    this.$collapseDiv.append("<div class='gf_collapse_toggle'></div>");
                    this.$gfDiv.append(this.$collapseDiv);
                    
                    this.$sliderDiv.on("mousedown", { self: this }, function (e) {
                        var $gf = e.data.self;
                        $gf.$sliderMoving = true;
                        $gf.$gfDiv.css("cursor", "e-resize");
                        //$gf.$gfDiv[0].onselectstart = function (e) { return false; };
                    });
                    this.$gfDiv.on("mousemove", { self: this }, function (e) {
                        var $gf = e.data.self;
                        if ($gf.$sliderMoving) {
                            $gf.sliderGhostMoving(e);
                        }
                    });
                    this.$gfDiv.on("mouseup", { self: this }, function (e) {
                        var $gf = e.data.self;
                        if ($gf.$sliderMoving) {
                            $gf.$sliderMoving = false;
                            $gf.sliderHorizontalMove(e);
                            $gf.$gfDiv.css("cursor", "default");
                        }
                    });
                    this.$propertyHeadDiv.children(".gf_p_head_toggle").on("click", { self: this }, function (e) {
                        var $gf = e.data.self;
                        $gf.reinitWidth($gf.$opts.width - 26 - $gf.$opts.sWidth, 26);
                    });
                    this.$collapseDiv.children(".gf_collapse_toggle").on("click", { self: this }, function (e) {
                        var $gf = e.data.self;
                        var dWidth = ($gf.$opts.width - $gf.$opts.sWidth) * 0.75;
                        var pWidth = $gf.$opts.width - dWidth - $gf.$opts.sWidth;
                        $gf.reinitWidth(dWidth, pWidth);
                    });

                    //创建属性实例
                    this.createPropery();
                }
            };
            //1.3创建流程模板属性及各结点属性实例
            p.createPropery = function () {
                //创建流程模板属性实例
                this.$templateProp = new TemplateProperty();
                this.$opts.templateOpts = $.extend({}, TemplateProperty.defaults, this.$opts.templateOpts);
                this.$templateProp.init(this, this.$propertyBodyDiv, this.$opts.templateOpts);
                this.$templateData = this.$templateProp.$opts.data;
                //创建开始节点属性实例
                this.$startProp = new StartProperty();
                this.$startProp.init(this.$propertyBodyDiv, StartProperty.defaults);
                //创建开始节点属性实例
                this.$endProp = new EndProperty();
                this.$endProp.init(this.$propertyBodyDiv, EndProperty.defaults);
                //创建活动节点属性实例
                this.$activityProp = new ActivityProperty();
                this.$opts.activityOpts = $.extend({}, ActivityProperty.defaults, this.$opts.activityOpts);
                this.$activityProp.init(this, this.$propertyBodyDiv, this.$opts.activityOpts);
                //创建连线属性实例
                this.$lineProp = new LineProperty();
                this.$opts.lineOpts = $.extend({}, LineProperty.defaults, this.$opts.lineOpts);
                this.$lineProp.init(this, this.$propertyBodyDiv, this.$opts.lineOpts);
                //创建条件节点属性实例
                this.$conditionProp = new ConditionProperty();
                this.$opts.conditionOpts = $.extend({}, ConditionProperty.defaults, this.$opts.conditionOpts);
                this.$conditionProp.init(this, this.$propertyBodyDiv, this.$opts.conditionOpts);
            };
            //1.4生成顶部工具栏
            p.createHead = function () {
                var w = this.$opts.dWidth - 10;
                this.$title = this.$opts.wfTitle || "新流程1";
                this.$designerHeadDiv = $(GoFlow.formatString("<div class='gf_d_head'><label style='width:{0}px;' title='{1}'>{1}</label></div>", w, this.$title));
                this.$designerDiv.append(this.$designerHeadDiv);
            };
            //1.5生成左侧工具栏
            p.createTool = function () {
                var height = this.$opts.height - (this.$opts.haveHead ? 31 : 10);
                this.$designerDiv.append(GoFlow.formatString("<div class='gf_d_tool'{0}></div>", this.$opts.haveHead ? "" : " style='margin-top:3px'"));
                this.$designerToolDiv = $(GoFlow.formatString("<div class='gf_d_tool_div' style='height:{0}px'></div>", height));
                this.$designerDiv.children(".gf_d_tool").append(this.$designerToolDiv);                
                //加入结点按钮
                this.$toolBox = $("<div class='gf_d_tool_div_box'></div>");
                this.$designerToolDiv.append(this.$toolBox);
                this.$toolBox.append("<a href='javascript:void(0)' class='gf_d_box_btndown' id='" + this.$id + "_btn_cursor' title='指针'><b class='ico_cursor'/></a>");//鼠标指针
                this.$toolBox.append("<a href='javascript:void(0)' class='gf_d_box_btn' id='" + this.$id + "_btn_line' title='连线'><b class='ico_line'/></a>");   //连线
                if (this.$opts.toolBoxBtn) {
                    var item = "<span/>";
                    var $id = this.$id;
                    var toolBoxBtn = this.$opts.toolBoxBtn;
                    $.each(toolBoxBtn, function (k, v) {
                        item += GoFlow.formatString("<a href='javascript:void(0)' id='{0}_btn_{1}' class='gf_d_box_btn'><b class='ico_{1}' title='{2}'/></a>", $id, k, v);
                    });
                    item += "<span/>";
                    this.$toolBox.append(item);
                }
                //绑定各个组件按钮的点击事件
                this.$toolBox.on("click", { self: this }, function (e) {
                    if (!e) e = window.event;
                    var tar;
                    switch (e.target.tagName) {
                        case "DIV": return false;
                        case "SPAN": return false;
                        case "A": tar = e.target; break;
                        case "B": tar = e.target.parentNode; break;
                    };
                    if ($(tar).attr("class") != "gf_d_box_btngray") {
                        var type = $(tar).attr("id").split("btn_")[1];
                        e.data.self.switchToolBtn(type);
                    }
                    return false;
                });
                //加入操作按钮
                this.$toolOper = $("<div class='gf_d_tool_div_opt'></div>");
                this.$designerToolDiv.append(this.$toolOper);
                if (this.$opts.toolOperBtn) {
                    var item = "<span/>";
                    var $id = this.$id;
                    var toolOperBtn = this.$opts.toolOperBtn;
                    $.each(toolOperBtn, function (k, v) {
                        item += GoFlow.formatString("<a href='javascript:void(0)' id='{0}_btn_{1}' class='gf_d_opt_btn' title='{2}'><b class='ico_{1}'></b></a>", $id, k, v);
                        if (k == "reload") item += "<span/>";
                    });
                    item += "<span/>";
                    this.$toolOper.append(item);
                }
                /*以下是当工具栏按钮被点击时触发的事件*/
                this.onBtnReloadClick = this.$opts.onBtnReloadClick;  //重载流程图按钮
                this.onBtnSaveClick = this.$opts.onBtnSaveClick;//保存流程图按钮
                this.onBtnPublishClick = this.$opts.onBtnPublishClick;//发布流程按钮
                this.onBtnReplaceClick = this.$opts.onBtnReplaceClick;  //覆盖流程按钮
                this.onBtnOpenClick = this.$opts.onBtnOpenClick; //打开流程按钮
                //绑定各个操作按钮的点击事件
                if (this.$opts.toolOperBtn) {
                    this.$toolOper.on("click", { self: this }, function (e) {
                        if (!e) e = window.event;
                        var tar = e.target;
                        if (tar.tagName == "a") tar = tar.childNode[0];
                        else if (tar.tagName == "DIV" || tar.tagName == "SPAN") return;
                        if ($(tar.parentNode).attr("class") == "gf_d_opt_btngray") return;
                        //定义操作按钮的事件
                        var $gf = e.data.self;
                        switch ($(tar).attr("class")) {
                            case "ico_undo": $gf.undo(); break;
                            case "ico_redo": $gf.redo(); break;
                            case "ico_reload":
                                if ($gf.onBtnReloadClick != null) {
                                    $gf.onBtnReloadClick();
                                }
                                break;
                            case "ico_save":
                                if ($gf.onBtnSaveClick != null) {
                                    $gf.onBtnSaveClick($gf.$templateData, $gf.$nodeData, $gf.$lineData);
                                }
                                break;
                            case "ico_publish":
                                if ($gf.onBtnPublishClick != null) {
                                    $gf.onBtnPublishClick($gf.$templateData);
                                }
                                break;
                            case "ico_replace":
                                if ($gf.onBtnReplaceClick != null) {
                                    $gf.onBtnReplaceClick($gf.$templateData);
                                }
                                break;
                            case "ico_open":
                                if ($gf.onBtnOpenClick != null) {
                                    $gf.onBtnOpenClick($gf.$templateData);
                                }
                                break;
                        }
                    });
                }
            };
            //1.6生成工作区域
            p.createWorkArea = function () {
                var w = this.$opts.dWidth - (this.$opts.haveTool ? 39 : 8);
                var h = this.$opts.height - (this.$opts.haveHead ? 29 : 8);
                this.$designerDiv.append(GoFlow.formatString(
                    "<div class='gf_d_work' style='width:{0}px;height:{1}px;{2}'></div>", w, h, this.$opts.haveHead ? "" : "margin-top:3px"));
                this.$workArea = $(GoFlow.formatString(
                    "<div class='gf_d_work_inner' style='width:{0}px;height:{1}px'></div>", this.$opts.workAreaWidth, this.$opts.workAreaHeight))
                    .attr({ "unselectable": "on", "onselectstart": 'return false', "onselect": 'document.selection.empty()' });
                this.$designerDiv.children(".gf_d_work").append(this.$workArea);
            };
            //1.7创建化画板（用于画线）
            p.createDrawBoard = function () {
                if (GoFlow.useSVG) {
                    this.$drawBoard = document.createElementNS("http://www.w3.org/2000/svg", "svg");
                    this.$workArea.prepend(this.$drawBoard);
                    var defs = document.createElementNS("http://www.w3.org/2000/svg", "defs");
                    this.$drawBoard.appendChild(defs);
                    defs.appendChild(GoFlow.getSvgMarker("arrow1", "#15428B"));
                    defs.appendChild(GoFlow.getSvgMarker("arrow2", "#ff3300"));
                    defs.appendChild(GoFlow.getSvgMarker("arrow3", "#ff3300"));
                }
                else {
                    this.$drawBoard = document.createElement("v:group");
                    this.$drawBoard.coordsize = this.$opts.workAreaWidth + "," + this.$opts.workAreaHeight;
                    this.$workArea.prepend(GoFlow.formatString(
                        "<div class='gf_d_work_vml' style='position:relative;width:{0}px;height:{1}px'></div>",
                        this.$opts.workAreaWidth, this.$opts.workAreaHeight));
                    this.$workArea.children("div")[0].insertBefore(this.$drawBoard, null);
                }
                this.$drawBoard.id = "draw_" + this.$id;
                this.$drawBoard.style.width = this.$opts.workAreaWidth + "px";
                this.$drawBoard.style.height = this.$opts.workAreaHeight + "px";
                //绑定连线的点击选中以及双击编辑事件
                var lineObj = GoFlow.useSVG ? "g" : "PolyLine";
                $(this.$drawBoard).delegate(lineObj, "click", { self: this }, function (e) {
                    e.data.self.focusItem(this.id, true);
                });
                if (this.$editable) {
                    $(this.$drawBoard).delegate(lineObj, "dblclick", { self: this }, function (e) {
                        /*var oldTxt, x, y, from, to;
                        var $gf = e.data.self;
                        if (GoFlow.useSVG) {
                            oldTxt = this.childNodes[2].textContent;
                            from = this.getAttribute("from").split(",");
                            to = this.getAttribute("to").split(",");
                        } else {
                            oldTxt = this.childNodes[1].innerHTML;
                            var n = this.getAttribute("fromTo").split(",");
                            from = [n[0], n[1]];
                            to = [n[2], n[3]];
                        }
                        if ($gf.$lineData[this.id].type == "Z") {
                            from[0] = $gf.$lineData[this.id].M;
                            to[0] = from[0];
                        }
                        else if ($gf.$lineData[this.id].type == "N") {
                            from[1] = $gf.$lineData[this.id].M;
                            to[1] = from[1];
                        }
                        x = (parseInt(from[0], 10) + parseInt(to[0], 10)) / 2 - 60;
                        y = (parseInt(from[1], 10) + parseInt(to[1], 10)) / 2 - 12;
                        var t = GoFlow.getElCoordinate($gf.$workArea[0]);
                        $gf.$textArea.val(oldTxt).css({
                            display: "block", width: 120, height: 14,
                            left: t.left + x - $gf.$workArea[0].parentNode.scrollLeft,
                            top: t.top + y - $gf.$workArea[0].parentNode.scrollTop
                        }).data("id", $gf.$focusId).focus();
                        $gf.$workArea.parent().one("mousedown", function (e) {
                            $gf.setItemTitle($gf.$textArea.data("id"), $gf.$textArea.val(), "line");
                            $gf.$textArea.val("").removeData("id").hide();
                        });*/
                    });
                }
            };
            //1.8初始化工作区事件
            p.bindWorkAreaDelegate = function () {
                this.$workArea.on("click", { self: this }, function (e) {
                    if (!e) e = window.event;
                    var $gf = e.data.self;
                    if (!$gf.$editable) return;
                    if ($gf.$curType == "cursor") { //取消选中
                        var t = $(e.target);
                        var n = t.prop("tagName");
                        if (n == "svg" || (n == "DIV" && t.prop("class").indexOf("gf_d_work") > -1)) {
                            $gf.blurItem();  //取消选中
                            $gf.switchPropery();
                        }
                    }
                    else if ($gf.$curType != "line") { //添加结点
                        var idx = $gf.getNodeIndex($gf.$curType);
                        var id = $gf.$curType + "_" + idx;
                        var title = ($gf.$curType == "start" && "开始")
                            || ($gf.$curType == "end" && "结束")
                            || ($gf.$curType == "activity" && "活动" + idx)
                            || ($gf.$curType == "condition" && "条件" + idx);
                        var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate(this);
                        var X = ev.x - t.left + this.parentNode.scrollLeft;
                        var Y = ev.y - t.top + this.parentNode.scrollTop;
                        $gf.addNode(id, { title: title, left: X, top: Y, type: $gf.$curType });
                    }
                });
                //划线时用的绑定
                this.$workArea.mousemove({ self: this }, function (e) {
                    if (e.data.self.$curType != "line") return;
                    var lineStart = $(this).data("lineStart");
                    if (!lineStart) return;
                    var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate(this);
                    var X, Y;
                    X = ev.x - t.left + this.parentNode.scrollLeft;
                    Y = ev.y - t.top + this.parentNode.scrollTop;
                    var line = document.getElementById("gf_d_tmp_line");
                    if (GoFlow.useSVG) {
                        line.childNodes[0].setAttribute("d", "M " + lineStart.x + " " + lineStart.y + " L " + X + " " + Y);
                        line.childNodes[1].setAttribute("d", "M " + lineStart.x + " " + lineStart.y + " L " + X + " " + Y);
                        if (line.childNodes[1].getAttribute("marker-end") == "url(\"#arrow2\")")
                            line.childNodes[1].setAttribute("marker-end", "url(#arrow3)");
                        else line.childNodes[1].setAttribute("marker-end", "url(#arrow2)");
                    }
                    else line.points.value = lineStart.x + "," + lineStart.y + " " + X + "," + Y;
                });
                this.$workArea.mouseup({ self: this }, function (e) {
                    if (e.data.self.$curType == "line") {
                        $(this).removeData("lineStart");
                        var domTmpLine = document.getElementById("gf_d_tmp_line");
                        if (domTmpLine) e.data.self.$drawBoard.removeChild(domTmpLine);
                    }
                });
            };
            //1.9初始化结点事件
            p.bindNodeDelegate = function () {
                //绑定点击事件
                this.$workArea.delegate(".gf_d_item", "click", { self: this }, function (e) {
                    e.data.self.focusItem(this.id, true);
                    $(this).removeClass("item_line_enter");
                    $(this).removeClass("item_cursor_enter");
                });
                if (!this.$editable) return;

                this.$workArea.delegate(".gf_d_item", "keydown", { self: this }, function (e) {
                    var id = this.id;
                    var $gf = e.data.self;
                    switch (e.which) {
                        case 37://往左
                            $gf.moveNode(id, $gf.$nodeData[id].left - 1, $gf.$nodeData[id].top);
                            break;
                        case 38://往上
                            $gf.moveNode(id, $gf.$nodeData[id].left, $gf.$nodeData[id].top - 1);
                            break;
                        case 39://往右
                            $gf.moveNode(id, $gf.$nodeData[id].left + 1, $gf.$nodeData[id].top);
                            break;
                        case 40://往下
                            $gf.moveNode(id, $gf.$nodeData[id].left, $gf.$nodeData[id].top + 1);
                            break;
                        default:
                            break;
                    }
                    return false;
                });
                //绑定鼠标覆盖/移出事件
                this.$workArea.delegate(".gf_d_item", "mouseenter", { self: this }, function (e) {
                    if (e.data.self.$curType == "cursor") {
                        $(this).addClass("item_cursor_enter");
                    }
                    else if (e.data.self.$curType == "line") {
                        $(this).addClass("item_line_enter");
                    }
                });
                this.$workArea.delegate(".gf_d_item", "mouseleave", { self: this }, function (e) {
                    var $gf = e.data.self;
                    if ($gf.$curType == "cursor") {
                        $gf.$nodeMoving = false;
                        $(this).removeClass("item_cursor_enter");
                    }
                    else if ($gf.$curType == "line") {
                        $(this).removeClass("item_line_enter");
                    }
                });
                this.$workArea.delegate(".gf_d_item", "mousemove", { self: this }, function (e) {
                    var $gf = e.data.self;
                    if ($gf.$curType == "cursor") {
                        if ($gf.$nodeMoving) {//确定节点移动初始点及绑定移动事件
                            if (!e) e = window.event;
                            var id = $(this).attr("id");
                            //$gf.focusItem(id, true);
                            var hack = (navigator.userAgent.indexOf("8.0") != -1 ? 0 : 1);
                            var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate($gf.$workArea[0]);
                            $gf.$ghost.css({
                                cursor: "move",
                                display: "block",
                                width: $gf.$nodeData[id].width - 2 + "px", height: $gf.$nodeData[id].height - 2 + "px",
                                top: $gf.$nodeData[id].top + t.top - $gf.$workArea[0].parentNode.scrollTop + hack + "px",
                                left: $gf.$nodeData[id].left + t.left - $gf.$workArea[0].parentNode.scrollLeft + hack + "px"
                            });
                            $(this).children("table").clone().prependTo($gf.$ghost);
                            var X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft;
                            var Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop;
                            var vX = X - $gf.$nodeData[id].left, vY = Y - $gf.$nodeData[id].top;
                            var isMove = false;
                            document.onmousemove = function (e) {
                                if (!e) e = window.event;
                                var ev = GoFlow.mousePosition(e);
                                X = ev.x - vX; Y = ev.y - vY;
                                if (X < t.left - $gf.$workArea[0].parentNode.scrollLeft)
                                    X = t.left - $gf.$workArea[0].parentNode.scrollLeft;
                                else if (X + $gf.$workArea[0].parentNode.scrollLeft + $gf.$nodeData[id].width > t.left + $gf.$workArea.width())
                                    X = t.left + $gf.$workArea.width() - $gf.$workArea[0].parentNode.scrollLeft - $gf.$nodeData[id].width;
                                if (Y < t.top - $gf.$workArea[0].parentNode.scrollTop)
                                    Y = t.top - $gf.$workArea[0].parentNode.scrollTop;
                                else if (Y + $gf.$workArea[0].parentNode.scrollTop + $gf.$nodeData[id].height > t.top + $gf.$workArea.height())
                                    Y = t.top + $gf.$workArea.height() - $gf.$workArea[0].parentNode.scrollTop - $gf.$nodeData[id].height;
                                $gf.$ghost.css({ left: X + hack + "px", top: Y + hack + "px" });
                                isMove = true;
                            }
                            document.onmouseup = function (e) {
                                if (isMove) {
                                    $gf.moveNode(id, X + $gf.$workArea[0].parentNode.scrollLeft - t.left,
                                                     Y + $gf.$workArea[0].parentNode.scrollTop - t.top);
                                }
                                $gf.$nodeMoving = false; 
                                $gf.focusItem(id, true);
                                $gf.$ghost.empty().hide();
                                document.onmousemove = null;
                                document.onmouseup = null;
                            }
                        }
                        else if (!$(this).hasClass("item_cursor_enter")) {
                            $(this).addClass("item_cursor_enter");
                        }
                    }
                });
                //绑定节点鼠标按下事件（一共有两种情况需要处理：1、当工具类型是线时；2、当工具类型是指针时。）
                this.$workArea.delegate(".gf_d_item", "mousedown", { self: this }, function (e) {
                    var $gf = e.data.self;
                    if ($gf.$curType == "line") {  //确定连线初始点
                        var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate($gf.$workArea[0]);
                        var X, Y;
                        X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft;
                        Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop;
                        $gf.$workArea.data("lineStart", { "x": X, "y": Y, "id": this.id });
                        var line = $gf.drawLine("gf_d_tmp_line", [X, Y], [X, Y], true, true);
                        $gf.$drawBoard.appendChild(line);
                    }
                    else if ($gf.$curType == "cursor") {
                        $gf.$nodeMoving = true;
                    }
                    else {
                        $gf.switchToolBtn();
                        $gf.$nodeMoving = true;
                        //$(this).removeClass("item_line_enter");
                        //$(this).addClass("item_cursor_enter");
                    }
                });
                //绑定连线时确定结束点
                this.$workArea.delegate(".gf_d_item", "mouseup", { self: this }, function (e) {
                    var $gf = e.data.self;
                    if ($gf.$curType == "line") {  //确定连线结束点并画线
                        var lineStart = $gf.$workArea.data("lineStart");
                        if (lineStart) $gf.addLine("line_" + $gf.getLineIndex(), { from: lineStart.id, to: this.id, title: "" });
                    }
                    else if ($gf.$curType == "cursor") {
                        $gf.$nodeMoving = false;
                    }
                });
                //绑定标题双击编辑事件（串签、并签和条件）
                this.$workArea.delegate("td.item_title", "dblclick", { self: this }, function (e) {
                    /*var $gf = e.data.self;
                    var oldTxt = this.innerHTML;
                    var id = $(this).parents(".gf_d_item").attr("id");
                    var t = GoFlow.getElCoordinate($gf.$workArea[0]);
                    $gf.$textArea.val(oldTxt).css({
                        display: "block", width: $(this).width() - 2, height: $(this).height() - 2,
                        left: t.left + 24 + $gf.$nodeData[id].left - $gf.$workArea[0].parentNode.scrollLeft,
                        top: t.top + 2 + $gf.$nodeData[id].top - $gf.$workArea[0].parentNode.scrollTop
                    }).data("id", $gf.$focusId).focus();
                    $gf.$workArea.parent().one("mousedown", function (e) {
                        $gf.setItemTitle($gf.$textArea.data("id"), $gf.$textArea.val(), $gf.$nodeData[id].type);
                        $gf.$textArea.val("").removeData("id").hide();
                    });*/
                });
                //绑定结点的删除功能
                this.$workArea.delegate(".rs_close", "click", { self: this }, function (e) {
                    if (!e) e = window.event;
                    e.data.self.delNode(e.data.self.$focusId);
                    return false;
                });
                //绑定结点的RESIZE功能
                this.$workArea.delegate(".gf_d_item > div > div[class!=rs_close]", "mousedown", { self: this }, function (e) {
                    if (!e) e = window.event;
                    var cursor = $(this).css("cursor");
                    if (cursor == "pointer") { return; }
                    var $gf = e.data.self;
                    var id = $gf.$focusId;
                    $gf.switchToolBtn();
                    e.cancelBubble = true;
                    e.stopPropagation();
                    var hack = 1;
                    if (navigator.userAgent.indexOf("8.0") != -1) hack = 0;
                    var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate($gf.$workArea[0]);
                    $gf.$ghost.css({
                        display: "block",
                        width: $gf.$nodeData[id].width - 2 + "px", height: $gf.$nodeData[id].height - 2 + "px",
                        top: $gf.$nodeData[id].top + t.top - $gf.$workArea[0].parentNode.scrollTop + hack + "px",
                        left: $gf.$nodeData[id].left + t.left - $gf.$workArea[0].parentNode.scrollLeft + hack + "px", cursor: cursor
                    });
                    var X, Y;
                    X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft;
                    Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop;
                    var vX = ($gf.$nodeData[id].left + $gf.$nodeData[id].width) - X;
                    var vY = ($gf.$nodeData[id].top + $gf.$nodeData[id].height) - Y;
                    var isMove = false;
                    $gf.$ghost.css("cursor", cursor);
                    document.onmousemove = function (e) {
                        if (!e) e = window.event;
                        var ev = GoFlow.mousePosition(e);
                        X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft - $gf.$nodeData[id].left + vX;
                        Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop - $gf.$nodeData[id].top + vY;
                        if (X < 86) X = 86;
                        if (Y < 24) Y = 24;
                        isMove = true;
                        switch (cursor) {
                            case "nw-resize": $gf.$ghost.css({ width: X - 2 + "px", height: Y - 2 + "px" }); break;
                            case "w-resize": $gf.$ghost.css({ width: X - 2 + "px" }); break;
                            case "n-resize": $gf.$ghost.css({ height: Y - 2 + "px" }); break;
                        }
                    }
                    document.onmouseup = function (e) {
                        $gf.$ghost.hide();
                        if (!isMove) return;
                        if (!e) e = window.event;
                        $gf.resizeNode(id, $gf.$ghost.outerWidth(), $gf.$ghost.outerHeight());
                        document.onmousemove = null;
                        document.onmouseup = null;
                    }
                });
            };
            //1.10绑定结点/线的一些操作事件
            p.bindItemOperEvent = function (opts) {
                /*下面绑定结点/线的一些操作事件,这些事件可直接通过this访问对象本身*/
                /*当操作某个单元（结点/线）被添加时，触发的方法，返回FALSE可阻止添加事件的发生
                //格式function(id,type,data)：id是单元的唯一标识ID,type是单元的种类,有"node","line"两种取值,data即addNode或addLine方法的第二个传参data.*/
                this.onItemAdd = this.$opts.onItemAdd;
                //当操作某个单元（结点/线/分组块）被删除时，触发的方法，返回FALSE可阻止删除事件的发生
                //格式function(id，type)：id是单元的唯一标识ID,type是单元的种类,有"node","line","area"三种取值
                this.onItemDel = this.$opts.onItemDel;
                //当操作某个单元（结点/分组块）被移动时，触发的方法，返回FALSE可阻止移动事件的发生
                //格式function(id，type,left,top)：id是单元的唯一标识ID,type是单元的种类,有"node","area"两种取值，线line不支持移动,left是新的左边距坐标，top是新的顶边距坐标
                this.onItemMove = this.$opts.onItemMove;
                //当操作某个单元（结点/线/分组块）被重命名时，触发的方法，返回FALSE可阻止重命名事件的发生
                //格式function(id,title,type)：id是单元的唯一标识ID,type是单元的种类,有"node","line","area"三种取值,title是新的标题
                this.onItemSetTitle = this.$opts.onItemSetTitle;
                //当操作某个单元（结点/线）被由不选中变成选中时，触发的方法，返回FALSE可阻止选中事件的发生
                //格式function(id,type)：id是单元的唯一标识ID,type是单元的种类,有"node","line"两种取值,"area"不支持被选中
                this.onItemFocus = this.$opts.onItemFocus;
                //当操作某个单元（结点/线）被由选中变成不选中时，触发的方法，返回FALSE可阻止取消选中事件的发生
                //格式function(id，type)：id是单元的唯一标识ID,type是单元的种类,有"node","line"两种取值,"area"不支持被取消选中
                this.onItemBlur = this.$opts.onItemBlur;
                //当操作某个单元（结点/分组块）被重定义大小或造型时，触发的方法，返回FALSE可阻止重定大小/造型事件的发生
                //格式function(id，type,width,height)：id是单元的唯一标识ID,type是单元的种类,有"node","line","area"三种取值;width是新的宽度,height是新的高度
                this.onItemResize = this.$opts.onItemResize;
                //当移动某条折线中段的位置，触发的方法，返回FALSE可阻止重定大小/造型事件的发生
                //格式function(id，M)：id是单元的唯一标识ID,M是中段的新X(或Y)的坐标
                this.onLineMove = this.$opts.onLineMove;
                //当变换某条连接线的类型，触发的方法，返回FALSE可阻止重定大小/造型事件的发生
                //格式function(id，type)：id是单元的唯一标识ID,type是连接线的新类型,"I":直线,"Z":中段可左右移动的折线,"N":中段可上下移动的折线
                this.onLineSetType = this.$opts.onLineSetType;
                //当用重色标注某个结点/转换线时触发的方法，返回FALSE可阻止重定大小/造型事件的发生
                //格式function(id，type，mark)：id是单元的唯一标识ID,type是单元类型（"node"结点,"line"转换线），mark为布尔值,表示是要标注TRUE还是取消标注FALSE
                this.onItemMark = this.$opts.onItemMark;
            };
            //1.11创建结点遮罩层、标题文本框、折线移动框
            p.createGhost = function () {
                //结点进行移动或者RESIZE时用来显示的遮罩层
                this.$ghost = $("<div class='rs_ghost'></div>").attr({ "unselectable": "on", "onselectstart": 'return false', "onselect": 'document.selection.empty()' });
                this.$designerDiv.append(this.$ghost);
                //标题录入文本框
                this.$textArea = $("<textarea></textarea>");
                this.$designerDiv.append(this.$textArea);
                //操作折线时的移动框
                this.$lineMove = $("<div class='gf_d_line_move' style='display:none'></div>");
                this.$workArea.append(this.$lineMove);
                this.$lineMove.on("mousedown", { self: this }, function (e) {
                    var lm = $(this);
                    lm.css({ "background-color": "#333" });
                    var $gf = e.data.self;
                    var ev = GoFlow.mousePosition(e), t = GoFlow.getElCoordinate($gf.$workArea[0]);
                    var X, Y;
                    X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft;
                    Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop;
                    var p = $gf.$lineMove.position();
                    var vX = X - p.left, vY = Y - p.top;
                    var isMove = false;
                    document.onmousemove = function (e) {
                        if (!e) e = window.event;
                        var ev = GoFlow.mousePosition(e);
                        var ps = $gf.$lineMove.position();
                        X = ev.x - t.left + $gf.$workArea[0].parentNode.scrollLeft;
                        Y = ev.y - t.top + $gf.$workArea[0].parentNode.scrollTop;
                        if ($gf.$lineMove.data("type") == "Z") {
                            X = X - vX;
                            if (X < 0) X = 0;
                            else if (X > $gf.$workArea.width())
                                X = $gf.$workArea.width();
                            $gf.$lineMove.css({ left: X + "px" });
                        }
                        else if ($gf.$lineMove.data("type") == "N") {
                            Y = Y - vY;
                            if (Y < 0) Y = 0;
                            else if (Y > $gf.$workArea.height())
                                Y = $gf.$workArea.height();
                            $gf.$lineMove.css({ top: Y + "px" });
                        }
                        isMove = true;
                    }
                    document.onmouseup = function (e) {
                        if (isMove) {
                            var p = $gf.$lineMove.position();
                            if ($gf.$lineMove.data("type") == "Z")
                                $gf.setLineM($gf.$lineMove.data("tid"), p.left + 3);
                            else if ($gf.$lineMove.data("type") == "N")
                                $gf.setLineM($gf.$lineMove.data("tid"), p.top + 3);
                        }
                        $gf.$lineMove.css({ "background-color": "transparent" });
                        if ($gf.$focusId == $gf.$lineMove.data("tid")) {
                            $gf.focusItem($gf.$lineMove.data("tid"));
                        }
                        document.onmousemove = null;
                        document.onmouseup = null;
                    }
                });
                //选定线时显示的操作框
                this.$lineOper = $("<div class='gf_d_line_oper' style='display:none'><b class='b_l1'></b><b class='b_l2'></b><b class='b_l3'></b><b class='b_x'></b></div>");
                this.$workArea.append(this.$lineOper);
                this.$lineOper.on("click", { self: this }, function (e) {
                    if (!e) e = window.event;
                    if (e.target.tagName != "B") return;
                    var $gf = e.data.self;
                    var id = $(this).data("tid");
                    switch ($(e.target).attr("class")) {
                        case "b_x":
                            $gf.delLine(id);
                            this.style.display = "none"; break;
                        case "b_l1":
                            $gf.setLineType(id, "Z"); break;
                        case "b_l2":
                            $gf.setLineType(id, "N"); break;
                        case "b_l3":
                            $gf.setLineType(id, "I"); break;
                    }
                });
            };
            //1.12初始化撤销操作/重做操作缓存栈
            p.initOperStack = function () {
                this.$undoStack = [];
                this.$redoStack = [];
                this.$isUndo = 0;
                //为了节省浏览器内存空间,undo/redo中的操作缓存栈,最多只可放40步操作;超过40步时,将自动删掉最旧的一个缓存
                this.pushOper = function (funcName, paras) {
                    var len = this.$undoStack.length;
                    if (this.$isUndo == 1) {
                        this.$redoStack.push([funcName, paras]);
                        this.$isUndo = false;
                        if (this.$redoStack.length > 40) this.$redoStack.shift();
                    } else {
                        this.$undoStack.push([funcName, paras]);
                        if (this.$undoStack.length > 40) this.$undoStack.shift();
                        if (this.$isUndo == 0) {
                            this.$redoStack.splice(0, this.$redoStack.length);
                        }
                        this.$isUndo = 0;
                    }
                };
                //将外部的方法加入到goflow对象的事务操作堆栈中,在过后的undo/redo操作中可以进行控制，一般用于对流程图以外的附加信息进行编辑的事务撤销/重做控制；
                //传参func为要执行方法对象,jsonPara为外部方法仅有的一个面向字面的JSON传参,由JSON对象带入所有要传的信息；
                //提示:为了让外部方法能够被UNDO/REDO,需要在编写这些外部方法实现时,加入对该方法执行后效果回退的另一个执行方法的pushExternalOper
                this.pushExternalOper = function (func, jsonPara) {
                    this.pushOper("externalFunc", [func, jsonPara]);
                };
                //撤销上一步操作
                this.undo = function () {
                    if (this.$undoStack.length == 0) return;
                    var item = this.$undoStack.pop();
                    this.$isUndo = 1;
                    if (item[0] == "externalFunc") {
                        item[1][0](item[1][1]);
                    }
                    else {
                        //传参的数量,最多支持5个.
                        switch (item[1].length) {
                            case 0: this[item[0]](); break;
                            case 1: this[item[0]](item[1][0]); break;
                            case 2: this[item[0]](item[1][0], item[1][1]); break;
                            case 3: this[item[0]](item[1][0], item[1][1], item[1][2]); break;
                            case 4: this[item[0]](item[1][0], item[1][1], item[1][2], item[1][3]); break;
                            case 5: this[item[0]](item[1][0], item[1][1], item[1][2], item[1][3], item[1][4]); break;
                        }
                    }
                };
                //重做最近一次被撤销的操作
                this.redo = function () {
                    if (this.$redoStack.length == 0) return;
                    var item = this.$redoStack.pop();
                    this.$isUndo = 2;
                    if (item[0] == "externalFunc") {
                        item[1][0](item[1][1]);
                    }
                    else {
                        //传参的数量,最多支持5个.
                        switch (item[1].length) {
                            case 0: this[item[0]](); break;
                            case 1: this[item[0]](item[1][0]); break;
                            case 2: this[item[0]](item[1][0], item[1][1]); break;
                            case 3: this[item[0]](item[1][0], item[1][1], item[1][2]); break;
                            case 4: this[item[0]](item[1][0], item[1][1], item[1][2], item[1][3]); break;
                            case 5: this[item[0]](item[1][0], item[1][1], item[1][2], item[1][3], item[1][4]); break;
                        }
                    }
                };
            };
            
            //切换左边工具栏按钮,传参type表示切换成哪种类型的按钮
            p.switchToolBtn = function (type) {
                type = type ? type : "cursor";
                this.$toolBox.children("#" + this.$id + "_btn_" + this.$curType).attr("class", "gf_d_box_btn");
                this.$curType = type;
                this.$toolBox.children("#" + this.$id + "_btn_" + this.$curType).attr("class", "gf_d_box_btndown");
                if (this.$textArea.css("display") == "none") this.$textArea.removeData("id").val("").hide();
                if (this.$curType == "cursor") {
                    this.$workArea.css("cursor", "default");
                }
                else if (this.$curType == "line") {
                    this.$workArea.css("cursor", "crosshair");
                }
                else {
                    this.$workArea.css("cursor", "help");
                }
            };
            //启/禁用左边工具栏按钮
            p.setToolBtnEnabled = function (b, btns) {
                if (btns) {
                    var $gf = this;
                    $.each(btns, function (i, n) {
                        var id = GoFlow.formatString("#{0}_btn_{1}", $gf.$id, n);
                        if (b) {
                            //$gf.$toolBox.children(id).attr("class", "gf_d_box_btn");
                            $gf.$toolOper.children(id).attr("class", "gf_d_opt_btn");
                        } else {
                            //$gf.$toolBox.children(id).attr("class", "gf_d_box_btngray");
                            $gf.$toolOper.children(id).attr("class", "gf_d_opt_btngray");
                        }
                    });
                } else {
                    if (b) {
                        this.$toolBox.children(".gf_d_box_btngray").attr("class", "gf_d_box_btn");
                        this.$toolOper.children(".gf_d_opt_btngray").attr("class", "gf_d_opt_btn");
                    } else {
                        this.switchToolBtn();
                        this.$toolBox.children(".gf_d_box_btn").attr("class", "gf_d_box_btngray");
                        this.$toolOper.children(".gf_d_opt_btn").not(":last").attr("class", "gf_d_opt_btngray");
                    }
                }
            };
            //启/禁用左边工具栏按钮（排除btns）
            p.setToolBtnEnabledEx = function (b, btns) {
                this.setToolBtnEnabled(b);
                this.setToolBtnEnabled(!b, btns);
            };
            //设置流程图的名称
            p.setGoFlowTitle = function (text) {
                this.$title = text;
                if (this.$designerHeadDiv) this.$designerHeadDiv.children("label").attr("title", text).text(text);
            };
            //设置结点/连线的文字信息
            p.setItemTitle = function (id, title, type) {
                var oldTitle;
                if (type == "line") {//如果是线
                    if (!this.$lineData[id]) return;
                    if (this.$lineData[id].title == title) return;
                    if (this.onItemSetTitle != null && !this.onItemSetTitle(id, title, type)) return;
                    oldTitle = this.$lineData[id].title;
                    this.$lineData[id].title = title;
                    if (GoFlow.useSVG) {
                        this.$lineDom[id].childNodes[2].textContent = title;
                    }
                    else {
                        this.$lineDom[id].childNodes[1].innerHTML = title;
                        var n = this.$lineDom[id].getAttribute("fromTo").split(",");
                        var x;
                        if (this.$lineData[id].type != "Z") {
                            x = (n[2] - n[0]) / 2;
                        }
                        else {
                            var Min = n[2] > n[0] ? n[0] : n[2];
                            if (Min > this.$lineData[id].M) Min = this.$lineData[id].M;
                            x = this.$lineData[id].M - Min;
                        }
                        if (x < 0) x = x * -1;
                        this.$lineDom[id].childNodes[1].style.left = x - this.$lineDom[id].childNodes[1].offsetWidth / 2 + 4 + "px";
                    }
                }
                else {//如果是结点
                    if (!this.$nodeData[id]) return;
                    if (this.$nodeData[id].title == title) return;
                    if (this.onItemSetTitle != null && !this.onItemSetTitle(id, title, type)) return;
                    oldTitle = this.$nodeData[id].title;
                    this.$nodeData[id].title = title;
                    if (this.$nodeData[id].type == "start"
                        || this.$nodeData[id].type == "end") {
                        this.$nodeDom[id].children(".span").text(title);
                    }
                    else {
                        //this.$nodeDom[id].find("td:eq(1)").text(title);
                        this.$nodeDom[id].find("td.item_title").text(title);
                        var hack = 0;
                        if (navigator.userAgent.indexOf("8.0") != -1) hack = 2;
                        var width = this.$nodeDom[id].outerWidth();
                        var height = this.$nodeDom[id].outerHeight();
                        this.$nodeDom[id].children("table").css({ width: width - 2 + "px", height: height - 2 + "px" });
                        this.$nodeData[id].width = width;
                        this.$nodeData[id].height = height;
                    }
                    //重画转换线
                    //this.resetLines(id, this.$nodeData[id]);
                }
                if (this.$undoStack) {
                    var paras = [id, oldTitle, type];
                    this.pushOper("setItemTitle", paras);
                }
            };
            //取消所有结点/连线被选定的状态
            p.blurItem = function () {
                if (this.$focusId != "") {
                    var jq = $("#" + this.$focusId);
                    if (jq.prop("tagName") == "DIV") {
                        if (this.onItemBlur != null && !this.onItemBlur(id, "node")) return false;
                        jq.removeClass("item_focus").children("div:eq(0)").css("display", "none");
                    }
                    else {
                        if (this.onItemBlur != null && !this.onItemBlur(id, "line")) return false;
                        if (GoFlow.useSVG) {
                            if (!this.$lineData[this.$focusId].marked) {
                                jq[0].childNodes[1].setAttribute("stroke", "#5068AE");
                                jq[0].childNodes[1].setAttribute("marker-end", "url(#arrow1)");
                            }
                        }
                        else {
                            if (!this.$lineData[this.$focusId].marked) jq[0].strokeColor = "#5068AE";
                        }
                        this.$lineMove.hide().removeData("type").removeData("tid");
                        if (this.$editable) this.$lineOper.hide().removeData("tid");
                    }
                }
                this.$focusId = "";
                return true;
            };
            //选定某个结点/转换线 bool:TRUE决定了要触发选中事件，FALSE则不触发选中事件，多用在程序内部调用。
            p.focusItem = function (id, bool) {
                var $item = $("#" + id);
                if ($item.length == 0) return;
                if (!this.blurItem()) return;//先执行"取消选中",如果返回FLASE,则也会阻止选定事件继续进行.
                if ($item.prop("tagName") == "DIV") {
                    if (bool && this.onItemFocus != null && !this.onItemFocus(id, "node")) return;
                    $item.addClass("item_focus");
                    this.$workArea.append($item);
                    if (this.$editable) {
                        $item.attr("tabindex", 0).focus();
                        $item.children("div:eq(0)").css("display", "block");
                    }
                }
                else {//如果是连接线
                    if (this.onItemFocus != null && !this.onItemFocus(id, "line")) return;
                    if (GoFlow.useSVG) {
                        $item[0].childNodes[1].setAttribute("stroke", "#ff3300");
                        $item[0].childNodes[1].setAttribute("marker-end", "url(#arrow2)");
                    }
                    else $item[0].strokeColor = "#ff3300";
                    if (!this.$editable) return;
                    var x, y, from, to;
                    if (GoFlow.useSVG) {
                        from = $item.attr("from").split(",");
                        to = $item.attr("to").split(",");
                    } else {
                        var n = $item[0].getAttribute("fromTo").split(",");
                        from = [n[0], n[1]];
                        to = [n[2], n[3]];
                    }
                    from[0] = parseInt(from[0], 10);
                    from[1] = parseInt(from[1], 10);
                    to[0] = parseInt(to[0], 10);
                    to[1] = parseInt(to[1], 10);
                    //var t=getElCoordinate(this.$workArea[0]);
                    if (this.$lineData[id].type == "Z") {
                        from[0] = this.$lineData[id].M;
                        to[0] = from[0];
                        this.$lineMove.css({
                            width: "5px", height: (to[1] - from[1]) * (to[1] > from[1] ? 1 : -1) + "px",
                            left: from[0] - 3 + "px",
                            top: (to[1] > from[1] ? from[1] : to[1]) + 1 + "px",
                            cursor: "e-resize", display: "block"
                        }).data({ "type": "Z", "tid": id });
                    }
                    else if (this.$lineData[id].type == "N") {
                        from[1] = this.$lineData[id].M;
                        to[1] = from[1];
                        this.$lineMove.css({
                            width: (to[0] - from[0]) * (to[0] > from[0] ? 1 : -1) + "px", height: "5px",
                            left: (to[0] > from[0] ? from[0] : to[0]) + 1 + "px",
                            top: from[1] - 3 + "px",
                            cursor: "s-resize", display: "block"
                        }).data({ "type": "N", "tid": id });
                    }
                    x = (from[0] + to[0]) / 2 - 35;
                    y = (from[1] + to[1]) / 2 + 6;
                    this.$lineOper.css({ display: "block", left: x + "px", top: y + "px" }).data("tid", id);
                }
                this.$focusId = id;
                this.switchToolBtn();
                if (this.$editable) {
                    this.switchPropery(id, $item.prop("tagName") == "DIV" ? this.$nodeData[id].type : "line");
                }
            };
            //设置属性标题
            p.setPropertyTitle = function (id, type) {
                var text =
                    type == "template" && "流程模板属性：" + this.$templateData.TemplateName
                    || type == "start" && "开始节点属性：" + this.$nodeData[id].title
                    || type == "end" && "结束节点属性：" + this.$nodeData[id].title
                    || type == "line" && "连线属性：" + id
                    || type == "activity" && "活动节点属性：" + this.$nodeData[id].title
                    || type == "condition" && "条件节点属性：" + this.$nodeData[id].title
                    || "";
                this.$propertyHeadDiv.children(".gf_p_head_inner").html(text);
            }
            //切换属性显示
            p.switchPropery = function (id, type) {
                type = type ? type : "template";
                this.setPropertyTitle(id, type);
                this.$templateProp.setVisible(type == "template");  //显示流程模板属性
                this.$startProp.setVisible(type == "start", type == "start" ? this.$nodeData[id] : null); //显示开始节点属性
                this.$endProp.setVisible(type == "end", type == "end" ? this.$nodeData[id] : null); //显示结束节点属性
                this.$lineProp.setVisible(type == "line", type == "line" ? this.$lineData[id].lineProperty : null);  //显示连线属性
                this.$activityProp.setVisible(type == "activity", type == "activity" ? this.$nodeData[id].activityProperty : null);  //显示活动节点属性
                this.$conditionProp.setVisible(type == "condition", type == "condition" ? this.$nodeData[id].conditionProperty : null);  //显示条件节点属性
            };
            //获取结点/连线的详细信息
            p.getItemInfo = function (id, type) {
                switch (type) {
                    case "node": return this.$nodeData[id] || null;
                    case "line": return this.$lineData[id] || null;
                    default: return null;
                }
            };            
            //用颜色标注/取消标注一个结点或转换线，常用于显示重点或流程的进度。
            //这是一个在编辑模式中无用,但是在纯浏览模式中非常有用的方法，实际运用中可用于跟踪流程的进度。
            p.markItem = function (id, type, mark) {
                if (type == "node") {
                    if (!this.$nodeData[id]) return;
                    if (this.onItemMark != null && !this.onItemMark(id, "node", mark)) return;
                    this.$nodeData[id].marked = mark || false;
                    if (mark) this.$nodeDom[id].addClass("item_mark");
                    else this.$nodeDom[id].removeClass("item_mark");

                } else if (type == "line") {
                    if (!this.$lineData[id]) return;
                    if (this.onItemMark != null && !this.onItemMark(id, "line", mark)) return;
                    this.$lineData[id].marked = mark || false;
                    if (GoFlow.useSVG) {
                        if (mark) {
                            this.$nodeDom[id].childNodes[1].setAttribute("stroke", "#ff3300");
                            this.$nodeDom[id].childNodes[1].setAttribute("marker-end", "url(#arrow2)");
                        } else {
                            this.$nodeDom[id].childNodes[1].setAttribute("stroke", "#5068AE");
                            this.$nodeDom[id].childNodes[1].setAttribute("marker-end", "url(#arrow1)");
                        }
                    } else {
                        if (mark) this.$nodeDom[id].strokeColor = "#ff3300";
                        else this.$nodeDom[id].strokeColor = "#5068AE"
                    }
                }
                if (this.$undoStatck) {
                    var paras = [id, type, !mark];
                    this.pushOper("markItem", paras);
                }
            };

            /*结点操作*/
            //增加结点时获取结点ID的索引
            p.getNodeIndex = function (type) {
                var idx = 1, ids = [];
                $.each(this.$nodeData, function (ii, item) {
                    if (item.type == type) ids.push(item.id);
                });
                if (ids.length > 0) {
                    ids.sort();
                    for (var i = 0; i < ids.length; i++) {
                        idx = i + 1;
                        if (ids[i].split("_")[1] != idx) break;
                    }
                    if (idx == ids.length) idx++;
                }
                return idx;
            };
            //增加一个流程结点,传参为一个JSON,有id,title,top,left,width,height,type(结点类型)等属性
            p.addNode = function (id, data) {
                if (this.onItemAdd != null && !this.onItemAdd(id, "node", data)) return;
                if (this.$undoStack) {
                    this.pushOper("delNode", [id]);
                }
                data.id = id;
                data.recno = data.recno ? data.recno : 0;
                data.orgno = data.orgno ? data.orgno : 0;
                data.tempno = this.$templateData.RecNo;
                var mark = data.mark ? " item_mark" : "";
                if (data.type == "start" || data.type == "end") {
                    if (data.type == "start") {
                        for (var i in this.$nodeData) {
                            if (this.$nodeData[i].type == "start") {
                                alert("流程只允许有一个开始节点！"); return false;
                            }
                        }
                    }
                    data.width = 24; data.height = 24;
                    this.$nodeDom[id] = $("<div class='gf_d_item item_round" + mark + "' id='" + id + "' style='left:" + data.left + "px;top:" + data.top + "px'><table cellspacing='0'><tr><td class='ico'><b class='ico_" + data.type + "'></b></td></tr></table><div  style='display:none'><div class='rs_close'></div></div><div class='item_title'>" + data.title + "</div></div>");
                }
                else if (data.type == "condition") {
                    data.width = data.width ? data.width : 102;
                    data.height = data.height ? data.height : 76;
                    if (data.top < 0) data.top = 0;
                    if (data.left < 0) data.left = 0;
                    data.conditionProperty = data.conditionProperty ? data.conditionProperty : $.extend({}, ConditionProperty.defaults.data, { "TempNo": data.tempno, "ElementNo": 0, "ConditionCode": id, "ConditionTitle": data.title });
                    this.$nodeDom[id] = $("<div class='gf_d_item item_condition" + mark + "' id='" + id + "' style='left:" + data.left + "px;top:" + data.top + "px'><table cellspacing='1' style='width:" + (data.width - 2) + "px;height:" + (data.height - 2) + "px;'><tr><td style='width:3px;'></td><td class='item_ico'><b class='ico_" + data.type + "'></b></td><td class='item_title'>" + data.title + "</td><td class='item_ico'>&nbsp;</td></tr></table><div style='display:none'><div class='rs_close'></div></div></div>");
                }
                else {
                    data.width = data.width ? data.width : 122;
                    data.height = data.height ? data.height : 52;
                    if (data.top < 0) data.top = 0;
                    if (data.left < 0) data.left = 0;
                    data.activityProperty = data.activityProperty ? data.activityProperty : $.extend({}, ActivityProperty.defaults.data, { "TempNo": data.tempno, "ElementNo": 0, "ActivityCode": id, "ActivityName": data.title });
                    this.$nodeDom[id] = $("<div class='gf_d_item" + mark + "' id='" + id + "' style='left:" + data.left + "px;top:" + data.top + "px'><table cellspacing='1' style='width:" + (data.width - 2) + "px;height:" + (data.height - 2) + "px;'><tr><td class='item_ico'><b class='ico_" + data.type + "'></b></td><td class='item_title'>" + data.title + "</td></tr></table><div style='display:none'><div class='rs_bottom'></div><div class='rs_right'></div><div class='rs_rb'></div><div class='rs_close'></div></div></div>");
                }
                var ua = navigator.userAgent.toLowerCase();
                if (ua.indexOf('msie') != -1 && ua.indexOf('8.0') != -1) {
                    this.$nodeDom[id].css("filter", "progid:DXImageTransform.Microsoft.Shadow(color=#94AAC2,direction=135,strength=2)");
                }
                this.$workArea.append(this.$nodeDom[id]);
                this.$nodeData[id] = data;
                this.$nodeCount++;
            };            
            //删除结点
            p.delNode = function (id) {
                if (!this.$nodeData[id]) return;
                if (this.$undoStack) {
                    var paras = [id, this.$nodeData[id]];
                    this.pushOper("addNode", paras);
                }
                if (this.onItemDel != null && !this.onItemDel(id, "node")) return;
                delete this.$nodeData[id];
                this.$nodeDom[id].remove();
                delete this.$nodeDom[id];
                this.$nodeCount--;
                if (this.$focusId == id) this.$focusId = "";
                for (var k in this.$lineData) {
                    if (this.$lineData[k].from == id || this.$lineData[k].to == id) {
                        this.$drawBoard.removeChild(this.$lineDom[k]);
                        delete this.$lineData[k];
                        delete this.$lineDom[k];
                    }
                }
            };
            //移动结点到一个新的位置
            p.moveNode = function (id, left, top) {
                if (!this.$nodeData[id]) return;
                if (this.onItemMove != null && !this.onItemMove(id, "node", left, top)) return;
                if (this.$undoStack) {
                    var paras = [id, this.$nodeData[id].left, this.$nodeData[id].top];
                    this.pushOper("moveNode", paras);
                }
                if (left < 0) left = 0;
                if (top < 0) top = 0;
                $("#" + id).css({ left: left + "px", top: top + "px" });
                this.$nodeData[id].left = left;
                this.$nodeData[id].top = top;
                //重画转换线
                this.resetLines(id, this.$nodeData[id]);
            };
            //设置结点的尺寸,仅支持非开始/结束结点
            p.resizeNode = function (id, width, height) {
                if (!this.$nodeData[id]) return;
                if (this.onItemResize != null && !this.onItemResize(id, "node", width, height)) return;
                if (this.$nodeData[id].type == "start" || this.$nodeData[id].type == "end") return;
                if (this.$undoStack) {
                    var paras = [id, this.$nodeData[id].width, this.$nodeData[id].height];
                    this.pushOper("resizeNode", paras);
                }
                var hack = 0;
                if (navigator.userAgent.indexOf("8.0") != -1) hack = 2;
                this.$nodeDom[id].children("table").css({ width: width - 2 + "px", height: height - 2 + "px" });
                width = this.$nodeDom[id].outerWidth() - hack;
                height = this.$nodeDom[id].outerHeight() - hack;
                this.$nodeDom[id].children("table").css({ width: width - 2 + "px", height: height - 2 + "px" });
                this.$nodeData[id].width = width;
                this.$nodeData[id].height = height;
                //重画转换线
                this.resetLines(id, this.$nodeData[id]);
            };

            /*以下为有关画线的方法*/
            //增加结点时获取结点ID的索引
            p.getLineIndex = function () {
                var idx = 1, ids = [];
                $.each(this.$lineData, function (ii, item) {
                    ids.push(item.id);
                });
                if (ids.length > 0) {
                    ids.sort();
                    for (var i = 0; i < ids.length; i++) {
                        idx = i + 1;
                        if (ids[i].split("_")[1] != idx) break;
                    }
                    if (idx == ids.length) idx++;
                }
                return idx;
            };
            //增加一条线(直线/折线)
            p.addLine = function (id, data) {
                //调用添加时事件
                if (this.onItemAdd != null &&
                    !this.onItemAdd(id, "line", data)) {
                    return;
                }
                //插入撤消堆栈
                if (this.$undoStack) {
                    this.pushOper("delLine", [id]);
                }
                //开始结点和结束结点不能相同
                if (data.from == data.to) return;
                //避免两个节点间不能有一条以上同向接连线
                for (var k in this.$lineData) {
                    if (data.from == this.$lineData[k].from
                        && data.to == this.$lineData[k].to) {
                        return;
                    }
                }
                //获取连线的（type、from、to、title、marked）数据
                var n1 = this.$nodeData[data.from]; //获取开始结点的数据
                var n2 = this.$nodeData[data.to];   //获取结束结点的数据
                if (!n1 || !n2) return;
                if (!data.type) {
                    data.type = this.calcLineType(n1, n2);
                }
                if (data.type != "I" && !data.M) {
                    data.M = this.getMValue(n1, n2, data.type);
                }
                var res = data.lineProperty && (data.type == "I" ?
                        { "start": [data.left, data.top], "end": [data.width, data.height] } :
                        {
                            "start": [data.left, data.top],
                            "m1": [data.lineProperty.M1x, data.lineProperty.M1y],
                            "m2": [data.lineProperty.M2x, data.lineProperty.M2y],
                            "end": [data.width, data.height]
                        })
                    || (data.type == "I" ? this.calcStartEnd(n1, n2) : this.calcPolyPoints(n1, n2, data.type, data.M));
                if (!res) return;
                this.$lineData[id] = {};
                this.$lineData[id].id = id;
                this.$lineData[id].type = data.type;
                this.$lineData[id].M = data.M;
                this.$lineData[id].from = data.from;
                this.$lineData[id].to = data.to;
                this.$lineData[id].title = data.title;
                this.$lineData[id].left = data.left ? data.left : res.start[0];
                this.$lineData[id].top = data.top ? data.top : res.start[1];
                this.$lineData[id].width = data.width ? data.width : res.end[0];
                this.$lineData[id].height = data.height ? data.height : res.end[1];
                this.$lineData[id].recno = data.recno ? data.recno : 0;
                this.$lineData[id].orgno = data.orgno ? data.orgno : 0;
                this.$lineData[id].tempno = this.$templateData.RecNo;
                this.$lineData[id].marked = data.mark ? data.mark : false;
                this.$lineData[id].lineProperty =
                    data.lineProperty ? data.lineProperty :
                    $.extend({}, LineProperty.defaults.data, {
                        "TempNo": data.tempno,
                        "LineCode": id,
                        "LineTitle": data.title,
                        "LineType": data.type,
                        "FromElementCode": this.$nodeData[data.from].id,
                        "FromElementName": this.$nodeData[data.from].title,
                        "ToElementCode": this.$nodeData[data.to].id,
                        "ToElementName": this.$nodeData[data.to].title,
                        "M": data.M,
                        "M1x": data.type == "I" ? "0" : res.m1[0],
                        "M1y": data.type == "I" ? "0" : res.m1[1],
                        "M2x": data.type == "I" ? "0" : res.m2[0],
                        "M2y": data.type == "I" ? "0" : res.m2[1]
                    });
                //画线并添加到画板
                if (this.$lineData[id].type == "I") {
                    this.$lineDom[id] = this.drawLine(id, res.start, res.end, data.mark);
                }
                else {
                    this.$lineDom[id] = this.drawPoly(id, res.start, res.m1, res.m2, res.end, data.mark);
                }
                this.$drawBoard.appendChild(this.$lineDom[id]);
                //设置标题
                if (GoFlow.useSVG) {
                    this.$lineDom[id].childNodes[2].textContent = data.title;
                }
                else {
                    this.$lineDom[id].childNodes[1].innerHTML = data.title;
                    if (this.$lineData[id].type != "I") {
                        var Min = (res.start[0] > res.end[0] ? res.end[0] : res.start[0]);
                        if (Min > res.m2[0]) Min = res.m2[0];
                        if (Min > res.m1[0]) Min = res.m1[0];
                        this.$lineDom[i].childNodes[1].style.left = (res.m2[0] + res.m1[0]) / 2 - Min - this.$lineDom[id].childNodes[1].offsetWidth / 2 + 4;
                        Min = (res.start[1] > res.end[1] ? res.end[1] : res.start[1]);
                        if (Min > res.m2[1]) Min = res.m2[1];
                        if (Min > res.m1[1]) Min = res.m1[1];
                        this.$lineDom[id].childNodes[1].style.top = (res.m2[1] + res.m1[1]) / 2 - Min - this.$lineDom[id].childNodes[1].offsetHeight / 2;
                    }
                    else {
                        this.$lineDom[id].childNodes[1].style.left =
                            ((res.end[0] - res.start[0]) * (res.end[0] > res.start[0] ? 1 : -1) - this.$lineDom[id].childNodes[1].offsetWidth) / 2 + 4;
                    }
                }
                //连线计数+1
                this.$lineCount++;
            };
            //删除一条线
            p.delLine = function (id) {
                if (!this.$lineData[id]) return;
                if (this.onItemDel != null && !this.onItemDel(id, "node")) return;
                if (this.$undoStack) {
                    var paras = [id, this.$lineData[id]];
                    this.pushOper("addLine", paras);
                }
                this.$drawBoard.removeChild(this.$lineDom[id]);
                delete this.$lineData[id];
                delete this.$lineDom[id];
                if (this.$focusId == id) this.$focusId = "";
                this.$lineCount--;
            };
            //重构所有连向某个结点的线的显示，传参结构为$nodeData数组的一个单元结构
            p.resetLines = function (id, node) {
                for (var i in this.$lineData) {
                    var other = null;//获取结束/开始结点的数据
                    var res;
                    if (this.$lineData[i].from == id) {//找结束点
                        other = this.$nodeData[this.$lineData[i].to] || null;
                        if (other == null) continue;
                        if (this.$lineData[i].type == "I")
                            res = this.calcStartEnd(node, other);
                        else
                            res = this.calcPolyPointsM(this.$lineData[i].id, node, other, this.$lineData[i].type, this.$lineData[i].M);
                        if (!res) break;
                    }
                    else if (this.$lineData[i].to == id) {//找开始点
                        other = this.$nodeData[this.$lineData[i].from] || null;
                        if (other == null) continue;
                        if (this.$lineData[i].type == "I")
                            res = this.calcStartEnd(other, node);
                        else
                            res = this.calcPolyPointsM(this.$lineData[i].id, other, node, this.$lineData[i].type, this.$lineData[i].M);
                        if (!res) break;
                    }
                    if (other == null) continue;
                    this.$drawBoard.removeChild(this.$lineDom[i]);                    
                    if (this.$lineData[i].type == "I") {
                        this.$lineDom[i] = this.drawLine(i, res.start, res.end, this.$lineData[i].marked);
                    }
                    else {
                        this.$lineDom[i] = this.drawPoly(i, res.start, res.m1, res.m2, res.end, this.$lineData[i].marked);
                    }
                    this.$drawBoard.appendChild(this.$lineDom[i]);
                    if (GoFlow.useSVG) {
                        this.$lineDom[i].childNodes[2].textContent = this.$lineData[i].title;
                    }
                    else {
                        this.$lineDom[i].childNodes[1].innerHTML = this.$lineData[i].title;
                        if (this.$lineData[i].type != "I") {
                            var Min = (res.start[0] > res.end[0] ? res.end[0] : res.start[0]);
                            if (Min > res.m2[0]) Min = res.m2[0];
                            if (Min > res.m1[0]) Min = res.m1[0];
                            this.$lineDom[i].childNodes[1].style.left = (res.m2[0] + res.m1[0]) / 2 - Min - this.$lineDom[i].childNodes[1].offsetWidth / 2 + 4;
                            Min = (res.start[1] > res.end[1] ? res.end[1] : res.start[1]);
                            if (Min > res.m2[1]) Min = res.m2[1];
                            if (Min > res.m1[1]) Min = res.m1[1];
                            this.$lineDom[i].childNodes[1].style.top = (res.m2[1] + res.m1[1]) / 2 - Min - this.$lineDom[i].childNodes[1].offsetHeight / 2 - 4;
                        }
                        else {
                            this.$lineDom[i].childNodes[1].style.left =
                                ((res.end[0] - res.start[0]) * (res.end[0] > res.start[0] ? 1 : -1) - this.$lineDom[i].childNodes[1].offsetWidth) / 2 + 4;
                        }
                    }
                    //更新连线位置
                    this.setLineDataPoints(i, res);
                }
            };
            //重新设置连线的样式 newType="I":直线；"Z":中段可左右移动型折线；"N":中段可上下移动型折线。
            p.setLineType = function (id, newType) {
                if (!newType || newType == null || newType == "" || newType == this.$lineData[id].type) return false;
                if (this.onLineSetType != null && !this.onLineSetType(id, newType)) return;
                if (this.$undoStack) {
                    var paras = [id, this.$lineData[id].type];
                    this.pushOper("setLineType", paras);
                    if (this.$lineData[id].type != "I") {
                        var para2 = [id, this.$lineData[id].M];
                        this.pushOper("setLineM", para2);
                    }
                }
                var from = this.$lineData[id].from;
                var to = this.$lineData[id].to;
                this.$lineData[id].type = newType;
                //如果是变成折线
                if (newType != "I") {
                    this.setLineM(id, this.getMValue(this.$nodeData[from], this.$nodeData[to], newType), true);
                }
                else { //如果是变回直线
                    delete this.$lineData[id].M;
                    this.$lineMove.hide().removeData("type").removeData("tid");
                    var res = this.calcStartEnd(this.$nodeData[from], this.$nodeData[to]);
                    if (!res) return;
                    this.$drawBoard.removeChild(this.$lineDom[id]);
                    this.$lineDom[id] = this.drawLine(id, res.start, res.end, this.$lineData[id].marked || this.$focusId == id);
                    this.$drawBoard.appendChild(this.$lineDom[id]);
                    if (GoFlow.useSVG) {
                        this.$lineDom[id].childNodes[2].textContent = this.$lineData[id].title;
                    }
                    else {
                        this.$lineDom[id].childNodes[1].innerHTML = this.$lineData[id].title;
                        this.$lineDom[id].childNodes[1].style.left =
                        ((res.end[0] - res.start[0]) * (res.end[0] > res.start[0] ? 1 : -1) - this.$lineDom[id].childNodes[1].offsetWidth) / 2 + 4;
                    }
                    //更新连线位置
                    this.setLineDataPoints(id, res);
                }
                if (this.$focusId == id) this.focusItem(id);
            };
            //计算两个结点间连线的类型
            p.calcLineType = function (n1, n2) {
                var x11 = n1.left, x12 = n1.left + n1.width, x21 = n2.left, x22 = n2.left + n2.width;
                var y11 = n1.top, y12 = n1.top + n1.height, y21 = n2.top, y22 = n2.top + n2.height;
                var x1m = (x11 + x12) / 2, x2m = (x21 + x22) / 2, y1m = (y11 + y12) / 2, y2m = (y21 + y22) / 2;
                if (x1m >= x22) {//结点2在结点1左边(x轴有交集)
                    if (y11 > y22) { //结点2在结点1左上方（y轴无交集）
                        return "N";
                    }
                    else if (y12 < y21) {//结点2在结点1左下方（y轴无交集）
                        return "N";
                    }
                    else {//y轴有交集 
                        return (Math.abs(y1m - y2m) < 20 ? "I" : "Z");
                    }
                }
                else { //结点2在结点1右边(x轴有交集)
                    if (y11 > y22) { //结点2在结点1右上方（y轴无交集）
                        return (Math.abs(x1m - x2m) < 20 ? "I" : "N");
                    }
                    else if (y12 < y21) {//结点2在结点1右下方（y轴无交集）
                        return (Math.abs(x1m - x2m) < 20 ? "I" : "N");
                    }
                    else {//y轴有交集 
                        return (Math.abs(y1m - y2m) < 20 ? "I" : "Z");
                    }
                }
            };
            //计算两个结点间连线的开始坐标和结束坐标
            p.calcStartEnd = function (n1, n2, type) {
                var X_1, Y_1, X_2, Y_2;
                var x11 = n1.left, x12 = n1.left + n1.width, x21 = n2.left, x22 = n2.left + n2.width;
                var y11 = n1.top, y12 = n1.top + n1.height, y21 = n2.top, y22 = n2.top + n2.height;
                var x1m = (x11 + x12) / 2, x2m = (x21 + x22) / 2, y1m = (y11 + y12) / 2, y2m = (y21 + y22) / 2;
                if (!type) type = "I";
                if (x1m >= x22) {//结点2在结点1左边(x轴有交集)
                    if (type == "N") {
                        if (y1m > y22) { //结点2在结点1左上方（y轴有交集）
                            X_1 = x1m; Y_1 = y11;
                            X_2 = x2m; Y_2 = y22;
                        }
                        else {//结点2在结点1左下方（y轴有交集）
                            X_1 = x1m; Y_1 = y12;
                            X_2 = x2m; Y_2 = y21;
                        }
                    }
                    else { //type等于Z或者I
                        X_1 = x11; Y_1 = y1m;
                        X_2 = x22; Y_2 = y2m;
                    }
                }
                else { //结点2在结点1右边(x轴有交集)
                    if (type == "Z") {
                        X_1 = x12; Y_1 = y1m;
                        X_2 = x21; Y_2 = y2m;
                    }
                    else { //type等于N或者I
                        if (y1m > y22) { //结点2在结点1右上方（y轴有交集）
                            X_1 = x1m; Y_1 = y11;
                            X_2 = x2m; Y_2 = y22;
                        }
                        else {//结点2在结点1右下方（y轴有交集）
                            if (type == "I" && Math.abs(y1m - y2m) < 20) {
                                X_1 = x12; Y_1 = y1m;
                                X_2 = x21; Y_2 = y2m;
                            }
                            else {
                                X_1 = x1m; Y_1 = y12;
                                X_2 = x2m; Y_2 = y21;
                            }
                        }
                    }
                }
                return { "start": [X_1, Y_1], "end": [X_2, Y_2] };
            };
            //计算两个结点间要连折线的所有坐标
            p.calcPolyPoints = function (n1, n2, type, M) {
                //开始/结束两个结点的中心
                var SP = { x: n1.left + n1.width / 2, y: n1.top + n1.height / 2 };
                var EP = { x: n2.left + n2.width / 2, y: n2.top + n2.height / 2 };
                var sp = [], m1 = [], m2 = [], ep = [];
                //粗略计算起始点
                sp = [SP.x, SP.y];
                ep = [EP.x, EP.y];
                //如果是允许中段可左右移动的折线,则参数M为可移动中段线的X坐标
                if (type == "Z") {
                    //粗略计算2个中点
                    m1 = [M, SP.y];
                    m2 = [M, EP.y];
                    //再具体分析修改开始点和中点1
                    if (m1[0] > n1.left && m1[0] < n1.left + n1.width) {
                        m1[1] = (SP.y > EP.y ? n1.top : n1.top + n1.height);
                        sp[0] = m1[0]; sp[1] = m1[1];
                    }
                    else {
                        sp[0] = (m1[0] < n1.left ? n1.left : n1.left + n1.width)
                    }
                    //再具体分析中点2和结束点
                    if (m2[0] > n2.left && m2[0] < n2.left + n2.width) {
                        m2[1] = (SP.y > EP.y ? n2.top + n2.height : n2.top);
                        ep[0] = m2[0]; ep[1] = m2[1];
                    }
                    else {
                        ep[0] = (m2[0] < n2.left ? n2.left : n2.left + n2.width)
                    }
                }
                //如果是允许中段可上下移动的折线,则参数M为可移动中段线的Y坐标
                else if (type == "N") {
                    //粗略计算2个中点
                    m1 = [SP.x, M];
                    m2 = [EP.x, M];
                    //再具体分析修改开始点和中点1
                    if (m1[1] > n1.top && m1[1] < n1.top + n1.height) {
                        m1[0] = (SP.x > EP.x ? n1.left : n1.left + n1.width);
                        sp[0] = m1[0]; sp[1] = m1[1];
                    }
                    else {
                        sp[1] = (m1[1] < n1.top ? n1.top : n1.top + n1.height)
                    }
                    //再具体分析中点2和结束点
                    if (m2[1] > n2.top && m2[1] < n2.top + n2.height) {
                        m2[0] = (SP.x > EP.x ? n2.left + n2.width : n2.left);
                        ep[0] = m2[0]; ep[1] = m2[1];
                    }
                    else {
                        ep[1] = (m2[1] < n2.top ? n2.top : n2.top + n2.height);
                    }
                }
                return { start: sp, m1: m1, m2: m2, end: ep };
            };
            //计算两个结点间要连折线的所有坐标，如果开始或者结束结点的坐标不在中间，则重设M位置后重新计算
            p.calcPolyPointsM = function (id, n1, n2, type, M) {
                var x1m = (n1.left * 2 + n1.width) / 2, y1m = (n1.top * 2 + n1.height) / 2;
                var x2m = (n2.left * 2 + n2.width) / 2, y2m = (n2.top * 2 + n2.height) / 2;
                var res = this.calcPolyPoints(n1, n2, type, M);
                if((res.start[0] != x1m && res.start[1] != y1m)
                    || (res.end[0] != x2m && res.end[1] != y2m)) {
                    M = this.getMValue(n1, n2, type);
                    this.setLineM(id, M);
                    res = this.calcPolyPoints(n1, n2, type, M);
                }
                return res;
            };
            //初始化折线中段的X/Y坐标,type='Z'时为X坐标,type='N'时为Y坐标
            p.getMValue = function (n1, n2, type) {
                var se = this.calcStartEnd(n1, n2, type);
                var x1 = se.start[0], y1 = se.start[1];
                var x2 = se.end[0], y2 = se.end[1];
                if (type == "Z") { //如果是允许中段可左右移动的折线,则计算X坐标
                    return (x1 + x2) / 2;
                }
                else if (type == "N") { //如果是允许中段可上下移动的折线,则计算Y坐标
                    return (y1 + y2) / 2;
                }
                else { //直线
                    return (x1 == x2) ? (y1 + y2) / 2 : (x1 + x2) / 2;
                }
            };
            //设置折线中段的X坐标值（可左右移动时）或Y坐标值（可上下移动时）
            p.setLineM = function (id, M, noStack) {
                if (!this.$lineData[id] || M < 0 || !this.$lineData[id].type || this.$lineData[id].type == "I") return false;
                if (this.onLineMove != null && !this.onLineMove(id, M)) return false;
                if (this.$undoStack && !noStack) {
                    var paras = [id, this.$lineData[id].M];
                    this.pushOper("setLineM", paras);
                }
                var from = this.$lineData[id].from;
                var to = this.$lineData[id].to;
                this.$lineData[id].M = M;
                var ps = this.calcPolyPoints(this.$nodeData[from], this.$nodeData[to], this.$lineData[id].type, this.$lineData[id].M);
                this.$drawBoard.removeChild(this.$lineDom[id]);
                this.$lineDom[id] = this.drawPoly(id, ps.start, ps.m1, ps.m2, ps.end, this.$lineData[id].marked || this.$focusId == id);
                this.$drawBoard.appendChild(this.$lineDom[id]);
                if (GoFlow.useSVG) {
                    this.$lineDom[id].childNodes[2].textContent = this.$lineData[id].title;
                }
                else {
                    this.$lineDom[id].childNodes[1].innerHTML = this.$lineData[id].title;
                    var Min = (ps.start[0] > ps.end[0] ? ps.end[0] : ps.start[0]);
                    if (Min > ps.m2[0]) Min = ps.m2[0];
                    if (Min > ps.m1[0]) Min = ps.m1[0];
                    this.$lineDom[id].childNodes[1].style.left = (ps.m2[0] + ps.m1[0]) / 2 - Min - this.$lineDom[id].childNodes[1].offsetWidth / 2 + 4;
                    Min = (ps.start[1] > ps.end[1] ? ps.end[1] : ps.start[1]);
                    if (Min > ps.m2[1]) Min = ps.m2[1];
                    if (Min > ps.m1[1]) Min = ps.m1[1];
                    this.$lineDom[id].childNodes[1].style.top = (ps.m2[1] + ps.m1[1]) / 2 - Min - this.$lineDom[id].childNodes[1].offsetHeight / 2 - 4;
                }
                //更新连线位置
                this.setLineDataPoints(id, ps);
            };
            //绘制一条带箭头直线，并返回线的DOM
            p.drawLine = function (id, sp, ep, mark, dash) {
                var line;
                if (GoFlow.useSVG) {
                    line = document.createElementNS("http://www.w3.org/2000/svg", "g");
                    var hi = document.createElementNS("http://www.w3.org/2000/svg", "path");
                    var path = document.createElementNS("http://www.w3.org/2000/svg", "path");

                    if (id != "") line.setAttribute("id", id);
                    line.setAttribute("from", sp[0] + "," + sp[1]);
                    line.setAttribute("to", ep[0] + "," + ep[1]);
                    hi.setAttribute("visibility", "hidden");
                    hi.setAttribute("stroke-width", 9);
                    hi.setAttribute("fill", "none");
                    hi.setAttribute("stroke", "white");
                    hi.setAttribute("d", "M " + sp[0] + " " + sp[1] + " L " + ep[0] + " " + ep[1]);
                    hi.setAttribute("pointer-events", "stroke");
                    path.setAttribute("d", "M " + sp[0] + " " + sp[1] + " L " + ep[0] + " " + ep[1]);
                    path.setAttribute("stroke-width", 1.4);
                    path.setAttribute("stroke-linecap", "round");
                    path.setAttribute("fill", "none");
                    if (dash) path.setAttribute("style", "stroke-dasharray:6,5");
                    if (mark) {
                        path.setAttribute("stroke", "#ff3300");
                        path.setAttribute("marker-end", "url(#arrow2)");
                    }
                    else {
                        path.setAttribute("stroke", "#5068AE");
                        path.setAttribute("marker-end", "url(#arrow1)");
                    }
                    line.appendChild(hi);
                    line.appendChild(path);
                    line.style.cursor = "crosshair";
                    if (id != "" && id != "gf_d_tmp_line") {
                        var text = document.createElementNS("http://www.w3.org/2000/svg", "text");
                        //text.textContent=id;
                        line.appendChild(text);
                        var x = (ep[0] + sp[0]) / 2;
                        var y = (ep[1] + sp[1]) / 2;
                        text.setAttribute("text-anchor", "middle");
                        text.setAttribute("x", x);
                        text.setAttribute("y", y);
                        line.style.cursor = "pointer";
                        text.style.cursor = "text";
                    }
                } else {
                    line = document.createElement("v:polyline");
                    if (id != "") line.id = id;
                    //line.style.position="absolute";
                    line.points.value = sp[0] + "," + sp[1] + " " + ep[0] + "," + ep[1];
                    line.setAttribute("fromTo", sp[0] + "," + sp[1] + "," + ep[0] + "," + ep[1]);
                    line.strokeWeight = "1.2";
                    line.stroke.EndArrow = "Block";
                    line.style.cursor = "crosshair";
                    if (id != "" && id != "gf_d_tmp_line") {
                        var text = document.createElement("div");
                        //text.innerHTML=id;
                        line.appendChild(text);
                        var x = (ep[0] - sp[0]) / 2;
                        var y = (ep[1] - sp[1]) / 2;
                        if (x < 0) x = x * -1;
                        if (y < 0) y = y * -1;
                        text.style.left = x + "px";
                        text.style.top = y - 6 + "px";
                        line.style.cursor = "pointer";
                    }
                    if (dash) line.stroke.dashstyle = "Dash";
                    if (mark) line.strokeColor = "#ff3300";
                    else line.strokeColor = "#5068AE";
                }
                return line;
            };
            //画一条只有两个中点的带箭头折线，并返回线的DOM
            p.drawPoly = function (id, sp, m1, m2, ep, mark) {
                var poly, strPath;
                if (GoFlow.useSVG) {
                    poly = document.createElementNS("http://www.w3.org/2000/svg", "g");
                    var hi = document.createElementNS("http://www.w3.org/2000/svg", "path");
                    var path = document.createElementNS("http://www.w3.org/2000/svg", "path");
                    if (id != "") poly.setAttribute("id", id);
                    poly.setAttribute("from", sp[0] + "," + sp[1]);
                    poly.setAttribute("to", ep[0] + "," + ep[1]);
                    hi.setAttribute("visibility", "hidden");
                    hi.setAttribute("stroke-width", 9);
                    hi.setAttribute("fill", "none");
                    hi.setAttribute("stroke", "white");
                    strPath = "M " + sp[0] + " " + sp[1];
                    if (m1[0] != sp[0] || m1[1] != sp[1])
                        strPath += " L " + m1[0] + " " + m1[1];
                    if (m2[0] != ep[0] || m2[1] != ep[1])
                        strPath += " L " + m2[0] + " " + m2[1];
                    strPath += " L " + ep[0] + " " + ep[1];
                    hi.setAttribute("d", strPath);
                    hi.setAttribute("pointer-events", "stroke");
                    path.setAttribute("d", strPath);
                    path.setAttribute("stroke-width", 1.4);
                    path.setAttribute("stroke-linecap", "round");
                    path.setAttribute("fill", "none");
                    if (mark) {
                        path.setAttribute("stroke", "#ff3300");
                        path.setAttribute("marker-end", "url(#arrow2)");
                    }
                    else {
                        path.setAttribute("stroke", "#5068AE");
                        path.setAttribute("marker-end", "url(#arrow1)");
                    }
                    poly.appendChild(hi);
                    poly.appendChild(path);
                    var text = document.createElementNS("http://www.w3.org/2000/svg", "text");
                    //text.textContent=id;
                    poly.appendChild(text);
                    var x = (m2[0] + m1[0]) / 2;
                    var y = (m2[1] + m1[1]) / 2;
                    text.setAttribute("text-anchor", "middle");
                    text.setAttribute("x", x);
                    text.setAttribute("y", y);
                    text.style.cursor = "text";
                    poly.style.cursor = "pointer";
                }
                else {
                    poly = document.createElement("v:Polyline");
                    if (id != "") poly.id = id;
                    poly.filled = "false";
                    strPath = sp[0] + "," + sp[1];
                    if (m1[0] != sp[0] || m1[1] != sp[1])
                        strPath += " " + m1[0] + "," + m1[1];
                    if (m2[0] != ep[0] || m2[1] != ep[1])
                        strPath += " " + m2[0] + "," + m2[1];
                    strPath += " " + ep[0] + "," + ep[1];
                    poly.points.value = strPath;
                    poly.setAttribute("fromTo", sp[0] + "," + sp[1] + "," + ep[0] + "," + ep[1]);
                    poly.strokeWeight = "1.2";
                    poly.stroke.EndArrow = "Block";
                    var text = document.createElement("div");
                    //text.innerHTML=id;
                    poly.appendChild(text);
                    var x = (m2[0] - m1[0]) / 2;
                    var y = (m2[1] - m1[1]) / 2;
                    if (x < 0) x = x * -1;
                    if (y < 0) y = y * -1;
                    text.style.left = x + "px";
                    text.style.top = y - 4 + "px";
                    poly.style.cursor = "pointer";
                    if (mark) poly.strokeColor = "#ff3300";
                    else poly.strokeColor = "#5068AE"
                }
                return poly;
            };
            //更新连线位置
            p.setLineDataPoints = function (id, points) {
                this.$lineData[id].left = points.start[0];
                this.$lineData[id].top = points.start[1];
                this.$lineData[id].width = points.end[0];
                this.$lineData[id].height = points.end[1];
                this.$lineData[id].lineProperty = $.extend({}, this.$lineData[id].lineProperty, {
                    "LineType": this.$lineData[id].type,
                    "M": this.$lineData[id].M,
                    "M1x": this.$lineData[id].type == "I" ? "0" : points.m1[0],
                    "M1y": this.$lineData[id].type == "I" ? "0" : points.m1[1],
                    "M2x": this.$lineData[id].type == "I" ? "0" : points.m2[0],
                    "M2y": this.$lineData[id].type == "I" ? "0" : points.m2[1]
                });
            }
            
            //分隔条幽灵左右拖动(mousemove)
            p.sliderGhostMoving = function (e) {
                var dWidth = GoFlow.mousePosition(e).x - 2;
                var pWidth = this.$opts.width - dWidth - this.$opts.sWidth;
                if (pWidth > 800 || dWidth < 100
                    || dWidth > this.$opts.width - this.$opts.sWidth) return;
                this.$sliderGhostDiv.css({ left: dWidth, display: "block" });
            };
            //完成分隔条左右拖动(mouseup)
            p.sliderHorizontalMove = function (e) {
                var dWidth = GoFlow.getElCoordinate(this.$sliderGhostDiv[0]).left - 2;
                var pWidth = this.$opts.width - dWidth - this.$opts.sWidth;
                if (pWidth < 27) {
                    pWidth = 26;
                    dWidth = this.$opts.width - pWidth - this.$opts.sWidth;
                }
                this.reinitWidth(dWidth, pWidth);
                this.$sliderGhostDiv.css("display", "none");
            };
            //设置设计器div和属性div的宽度
            p.reinitWidth = function (dWidth, pWidth) {
                if (pWidth <= 26) {
                    this.$collapseDiv.css("display", "block");
                    this.$propertyDiv.css("display", "none");
                }
                else {
                    this.$propertyDiv.css("display", "block");
                    this.$collapseDiv.css("display", "none");
                }
                this.$opts.dWidth = dWidth;
                this.$opts.pWidth = pWidth;
                this.$designerDiv.css("width", this.$opts.dWidth + "px");
                this.$propertyDiv.css("width", this.$opts.pWidth - 2 + "px");
                this.$propertyHeadDiv.css("width", this.$opts.pWidth - 2 + "px");
                if (this.$designerHeadDiv != null) {
                    this.$designerHeadDiv.children("label").css("width", this.$opts.dWidth - 10 + "px");
                }
                this.$workArea.parent().css("width", this.$opts.dWidth - 39 + "px");
            };
            //重构整个流程图设计器的宽高
            p.reinitSize = function (width, height) {
                var w = (width || 800) - 2;
                var h = (height || 500) - 2;
                this.$opts.width = w;
                this.$opts.height = h;
                this.calcWidth();
                this.$designerDiv.css({ height: h + "px", width: this.$opts.dWidth + "px" });
                if (this.$editable) {
                    this.$sliderDiv.css("height", h + "px");
                    this.$sliderGhostDiv.css("height", h + "px");
                    this.$propertyDiv.css({ height: h + "px", width: this.$opts.pWidth - 2 + "px" });
                    this.$propertyHeadDiv.css("width", this.$opts.pWidth - 2 + "px");
                    this.$propertyBodyDiv.css("height", h - 29 + "px");
                    this.$collapseDiv.css("height", h + "px");
                }
                var headHeight = 0, hack = 10;
                if (this.$designerHeadDiv != null) {
                    headHeight = 24;
                    hack = 7;
                }
                if (this.$designerToolDiv != null) {
                    this.$designerToolDiv.css({ height: h - headHeight - hack + "px" });
                }
                if (this.$designerHeadDiv != null) {
                    this.$designerHeadDiv.children("label").css({ width: this.$opts.dWidth - 10 + "px" });
                }
                w = this.$opts.dWidth - 39;
                h = h - headHeight - (this.$designerHeadDiv != null ? 5 : 8);
                this.$workArea.parent().css({ height: h + "px", width: w + "px" });
            };
            //重新设置工作区域的大小
            p.resizeWorkArea = function (width, height) {
                this.$opts.workAreaWidth = width;
                this.$opts.workAreaHeight = height;
                this.$workArea.css({ 'width': width, 'height': height });
                if (!GoFlow.useSVG) {
                    this.$drawBoard.coordsize = width + "," + height;
                    this.$drawBoard.find(".gf_d_work_vml").css({ 'width': width, 'height': height });
                }
                this.$drawBoard.style.width = width + "px";
                this.$drawBoard.style.height = height + "px";
            };
        }
    };    
    //初始化GoFlow对象（gfDiv:jQuery对象；opts:参数）
    GoFlow.prototype.init = function (gfDiv, opts) {
        //保存设计器div:jQuery对象
        $(this).data('gfDiv', gfDiv);
        //定义goflow的属性
        this.$id = gfDiv.attr("id");
        this.$opts = opts;
        this.$gfDiv = gfDiv;
        this.$designerDiv = null; //设计器div
        this.$sliderDiv = null; //分隔条div
        this.$sliderGhostDiv = null; //分隔条移动div
        this.$propertyDiv = null; //属性div
        this.$collapseDiv = null; //属性收缩起来后显示的div
        this.$designerHeadDiv = null; //设计器顶部标签
        this.$propertyHeadDiv = null; //属性顶部标签
        this.$propertyBodyDiv = null; //属性容器
        this.$designerToolDiv = null; //左侧工具栏对象
        this.$toolOper = null; //左侧工具栏（操作）对象
        this.$toolBox = null; //左侧工具栏（工具箱）对象
        this.$workArea = null; //工作区域（结点、画板的容器）
        this.$drawBoard = null; //画板（矢量线条的容器）
        this.$templateProp = null; //流程模板属性
        this.$templateData = null; //流程模板数据
        this.$startProp = null;    //开始节点属性
        this.$endProp = null;    //结束节点属性
        this.$lineProp = null; //连线属性
        this.$activityProp = null;  //活动节点属性
        this.$conditionProp = null;  //条件节点属性
        this.$title = null; //流程的名称
        this.$curType = "cursor"; //当前要绘制的对象类型（默认为指针）
        this.$cursor = "default"; //鼠标指针在工作区内的样式
        this.$lineCount = 0;
        this.$nodeCount = 0;
        this.$lineData = {};
        this.$nodeData = {};
        this.$lineDom = {};
        this.$nodeDom = {};
        this.$focusId = "";//当前被选定的结点/转换线ID,如果没选中或者工作区被清空,则为""
        this.$editable = this.$opts.haveTool ? true : false;//工作区是否可编辑（只有具有工具栏时可编辑）
        this.$nodeMoving = false;//是否正在进行结点移动。
        this.$sliderMoving = false;//是否正在进行左右分隔移动。
        
        //设计器宽高
        this.$opts.width -= 2;
        this.$opts.height -= 2;
        //添样式
        this.$gfDiv.addClass("gf");
        //生成布局
        this.createDiv();
        //生成顶部工具栏
        if (this.$opts.haveHead) {
            this.createHead();
        }
        //生成左侧工具栏
        if (this.$opts.haveTool) {
            this.createTool();
        }
        //生成工作区域
        this.createWorkArea();
        //初始化画板
        this.createDrawBoard();
        //如果是可编辑状态，则绑定操作事件
        if (this.$editable) {
            //工作区delegate绑定事件
            this.bindWorkAreaDelegate();
            //针对结点的一些集体delegate绑定事件
            this.bindNodeDelegate();
            //绑定结点/线的一些操作事件
            this.bindItemOperEvent();
            //创建结点遮罩层、标题文本框、折线移动框
            this.createGhost();   
            //如果要使用堆栈记录操作并提供“撤销/重做”的功能
            if (this.$opts.useOperStack) {
                this.initOperStack();
            }
        }
    };

    //插件的定义    
    $.fn.goflow = function (opts) {
        return this.map(function () {
            var $this = $(this);

            if (opts == null
                && $this.data('goflow')) {
                return $this.data('goflow');
            }
            
            // 创建GoFlow实例
            var instance = new GoFlow();
            // 合并参数
            opts = $.extend(true, {}, GoFlow.defaults, opts);
            // 初始化
            instance.init($this, opts);
            // 保存实例
            $this.data('goflow', instance);

            return instance.gfDiv()[0];
        });        
    };
})(jQuery); //闭包结束  